
/* ************************************************************************
*  File: actmob.c                                             Part of ACT *
*  Usage: Loading/saving chars, booting/resetting world, internal funcs   *
*                                                                         *
*  All rights reserved.  See license.doc for complete information.        *
*                                                                         *
*  Copyright (C) 1993, 94 by the Trustees of the Johns Hopkins University *
*  CircleMUD is based on DikuMUD, Copyright (C) 1990, 1991.               *
************************************************************************ */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "act.h"

char buf[MAX_STRING_LENGTH], buf1[MAX_STRING_LENGTH], buf2[MAX_STRING_LENGTH];
extern char *action_bits[];
extern char *affected_bits[];
extern char *genders[];
extern char *position_types[];

void parse_mobile(FILE * mob_f, int nr, FILE *actfile)
{
  int t[10], cnt;
  char line[256], letter;

  /***** String data *** */
  fread_string(mob_f, buf2, actfile);			/* Name */
  fread_string(mob_f, buf2, actfile);			/* Short Desc */
  fread_string(mob_f, buf2, actfile);			/* Long Desc */
  fread_string(mob_f, buf2, actfile);			/* Action Desc */

  /* *** Numeric data *** */
  get_line(mob_f, line, actfile);
  sscanf(line, "%d %d %d %c", t, t + 1, t + 2, &letter);
  fprintf(actfile, "%s ", bitvector_to_string(t[0], action_bits));
  fprintf(actfile, "%s ", bitvector_to_string(t[1], affected_bits));
  fprintf(actfile, "%d %c\n", t[2], letter);

  switch (letter) {
  case 'S':						/* Simple monsters */
    get_line(mob_f, line, actfile);
    fprintf(actfile, "%s\n", line);			/* Lvl Hit AC HP DAM */

    get_line(mob_f, line, actfile);
    sscanf(line, " %d %d ", t, t + 1);
    fprintf(actfile, "%d %d\n", t[0], t[1]);		/* Gold Xp */

    get_line(mob_f, line, actfile);
    cnt = sscanf(line, "%d %d %d %d", t, t + 1, t + 2, t + 3);
    fprintf(actfile, "%s ", select_to_string(t[0], position_types));
    fprintf(actfile, "%s ", select_to_string(t[1], position_types));
    fprintf(actfile, "%s ", select_to_string(t[2], genders));
    if (cnt == 4)
      fprintf(actfile, "%d", t[3]);
    fprintf(actfile, "\n");
    break;
  default:
    fprintf(stderr, "Unsupported mob type %c in mob #%d\n", letter, nr);
    exit(1);
    break;
  }
}

