/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#define NEW_BUFFERSoff

/* rather than doing these over and over again, define once here and use the
   defines in the other defines.  JAB */

#define BIT_1            1U
#define BIT_2            2U
#define BIT_3            4U
#define BIT_4            8U
#define BIT_5           16U
#define BIT_6           32U
#define BIT_7           64U
#define BIT_8          128U
#define BIT_9          256U
#define BIT_10         512U
#define BIT_11        1024U
#define BIT_12        2048U
#define BIT_13        4096U
#define BIT_14        8192U
#define BIT_15       16384U
#define BIT_16       32768U
#define BIT_17       65536U
#define BIT_18      131072U
#define BIT_19      262144U
#define BIT_20      524288U
#define BIT_21     1048576U
#define BIT_22     2097152U
#define BIT_23     4194304U
#define BIT_24     8388608U
#define BIT_25    16777216U
#define BIT_26    33554432U
#define BIT_27    67108864U
#define BIT_28   134217728U
#define BIT_29   268435456U
#define BIT_30   536870912U
#define BIT_31  1073741824U
#define BIT_32  2147483648U

/* preamble ************************************************************ */

#define NOWHERE    -1		/* nil reference for room-database        */
#define NOTHING	   -1		/* nil reference for objects              */
#define NOBODY	   -1		/* nil reference for mobiles              */

#define SPECIAL(name) \
   int (name)(struct char_data *ch, void *me, int cmd, char *command, char *argument)

/* misc editor defines ************************************************* */

/* format modes for format_text */
#define FORMAT_INDENT		(1 << 0)

#define EVENTFUNC(name) long (name)(void *event_obj)


/* room-related defines ************************************************ */


/* The cardinal directions: used as index to room_data.dir_option[] */
#define NORTH          0
#define EAST           1
#define SOUTH          2
#define WEST           3
#define UP             4
#define DOWN           5
#define NORTHEAST      6
#define NORTHWEST      7
#define SOUTHEAST      8
#define SOUTHWEST      9


/* Room map specials */
#define ROOM_MAP_SPECIALS_NONE	  	  (1 << 0)
#define ROOM_MAP_SPECIALS_COLUMNS	  (1 << 1)
#define ROOM_MAP_SPECIALS_RIVER		  (1 << 2)

#define NUM_ROOM_MAP_SPECIALS		3

/* Room flags: used in room_data.room_flags */
/* WARNING: In the world files, NEVER set the bits marked "R" ("Reserved") */
#define ROOM_DARK		(1 << 0)	/* Dark                   */
#define ROOM_DEATH		(1 << 1)	/* Death trap             */
#define ROOM_NOMOB		(1 << 2)	/* MOBs not allowed               */
#define ROOM_INDOORS		(1 << 3)	/* Indoors                        */
#define ROOM_PEACEFUL		(1 << 4)	/* Violence not allowed   */
#define ROOM_SOUNDPROOF		(1 << 5)	/* Shouts, gossip blocked */
#define ROOM_NOTRACK		(1 << 6)	/* Track won't go through */
#define ROOM_NOMAGIC		(1 << 7)	/* Magic not allowed              */
#define ROOM_TUNNEL		(1 << 8)	/* room for only 1 pers   */
#define ROOM_PRIVATE		(1 << 9)	/* Can't teleport in              */
#define ROOM_GODROOM		(1 << 10)	/* LVL_GOD+ only allowed  */
#define ROOM_HOUSE		(1 << 11)	/* (R) Room is a house    */
#define ROOM_HOUSE_CRASH	(1 << 12)	/* (R) House needs saving */
#define ROOM_ATRIUM		(1 << 13)	/* (R) The door to a house        */
#define ROOM_OLC		(1 << 14)	/* (R) Modifyable/!compress       */
#define ROOM_BFS_MARK		(1 << 15)	/* (R) breath-first srch mrk      */


/* Exit info: used in room_data.dir_option.exit_info */
#define EX_ISDOOR		(1 << 0)	/* Exit is a door         */
#define EX_CLOSED		(1 << 1)	/* The door is closed     */
#define EX_LOCKED		(1 << 2)	/* The door is locked     */
#define EX_PICKPROOF		(1 << 3)	/* Lock can't be picked   */
#define EX_SECRET		(1 << 4)	/* Must search to reveal  */
#define EX_BLOCKED		(1 << 5)	/* Must trigger to open   */
#define EX_WALLED		(1 << 6)	/* A spell is blocking it */
#define EX_LARGE		(1 << 7)	/* Extra wide door, 3 squares */
#define EX_STAIRS		(1 << 8)	/* Is the up a stair, or wall? */
#define EX_NOWALL		(1 << 9)	/* No walls, entire size of room */
#define EX_NOSEE		(1 << 10)	/* Not a door, only set as one */
					   /* so we can get map fancy    */
#define EX_LADDER		(1 << 11)	/* vertical stair, may fall*/
#define EX_STONE		(1 << 12)	/* tough to break */
#define EX_METAL		(1 << 13)
#define EX_SMASHED		(1 << 14)	/* they got through 	*/
#define EX_NOMOB		(1 << 15)	/* similar to nomob rooms*/
#define EX_SPIKED		(1 << 16)	/* A spike holds is position      */
#define EX_TWOOD		(1 << 17)	/* thicker 		*/
#define EX_TSTONE		(1 << 18)
#define EX_TMETAL		(1 << 19)
#define EX_BARS			(1 << 20)
#define NUM_DOOR_FLAGS		21

/* Room shapes: */
#define ROOM_SHAPE_SQUARE 	0
#define ROOM_SHAPE_CIRCLE	1
#define ROOM_SHAPE_OCTAGON	2
#define ROOM_SHAPE_ROUGH	3
#define ROOM_SHAPE_WILDERNESS	4
#define ROOM_SHAPE_PCMAP	5

#define NUM_ROOM_SHAPES		6

/* Sector types: used in room_data.sector_type */
#define SECT_INSIDE          0	/* Indoors                        */
#define SECT_CITY            1	/* In a city                      */
#define SECT_FIELD           2	/* In a field             */
#define SECT_FOREST          3	/* In a forest            */
#define SECT_HILLS           4	/* In the hills           */
#define SECT_MOUNTAIN        5	/* On a mountain          */
#define SECT_WATER_SWIM      6	/* Swimmable water                */
#define SECT_WATER_NOSWIM    7	/* Water - need a boat    */
#define SECT_UNDERWATER	     8	/* Underwater             */
#define SECT_FLYING	     9	/* Wheee!                 */
#define SECT_ROAD	     10	/* Any road or street     */
#define SECT_SWAMP	     11	/* In a swamp             */
#define SECT_CAVE	     12	/* Underground            */

/* char and mob-related defines **************************************** */


/* PC classes */
#define CLASS_UNDEFINED	  -1
#define CLASS_CLERIC      0
#define CLASS_DRUID	  1
#define CLASS_FIGHTER     2
#define CLASS_PALADIN	  3
#define CLASS_RANGER	  4
#define CLASS_MAGIC_USER  5
#define CLASS_ILLUSIONIST 6
#define CLASS_THIEF	  7
#define CLASS_BARD	  8
#define CLASS_MULTI_C_M   9
#define CLASS_MULTI_F_M   10
#define CLASS_MULTI_F_T   11
#define CLASS_MULTI_M_T   12
#define CLASS_MULTI_F_M_T 13
#define CLASS_MULTI_C_R   14
#define CLASS_MULTI_C_F   15
#define CLASS_MULTI_I_T   16
#define CLASS_MULTI_C_F_M 17
#define CLASS_MULTI_C_T   18
#define CLASS_MULTI_F_I   19
#define CLASS_MULTI_C_I   20

#define NUM_CLASSES	  21	/* This must be the number of classes!! */

/* Races */
#define RACE_NONE             0
#define RACE_HUMAN            1
#define RACE_HALFELF          2
#define RACE_ELF              3
#define RACE_DWARF            4
#define RACE_HALFLING         5
#define RACE_GNOME            6
#define RACE_HALFORC	      7

#define NUM_PC_RACES          7

/* leaving a 10 slot 'gap' here, should be enough to handle future races */
/* stealing some of these outright from the silly src, smile */

#define RACE_ANKHEG			30
#define RACE_AARAKOCRA			31
#define RACE_ABOLETH			32
#define RACE_ARCANE			33
#define RACE_ARGOS			34
#define RACE_BAATEZU			35
#define RACE_AURUMVORAX			36
#define RACE_DROW			37
#define RACE_BANSHEE			38
#define RACE_BASILISK			39
#define RACE_BAT			40
#define RACE_BEAR			41
#define RACE_BEETLE_GIANT		42
#define RACE_BEHOLDER			43
#define RACE_BEHIR			44
#define RACE_BIRD			45
#define RACE_BRAIN_MOLE			46
#define RACE_BROWNIE			47
#define RACE_BUGBEAR			48
#define RACE_BULETTE			49
#define RACE_BULLYWUG			50
#define RACE_CARRION_CRAWLER		51
#define RACE_CAT_GREAT			52
#define RACE_CATOBLEPAS			53
#define RACE_CAVE_FISHER		54
#define RACE_CENTAUR			55
#define RACE_CENTIPEDE			56
#define RACE_CHIMERA			57
#define RACE_GORGIMERA			58
#define RACE_CLOAKER			59
#define RACE_COCKATRICE			60
#define RACE_COUATL			61
#define RACE_CRABMAN			62
#define RACE_CRAWLING_CLAW		63
#define RACE_CROCODILE			64
#define RACE_CRUSTACEAN_GIANT		65
#define RACE_CRYPT_THING		66
#define RACE_DEATH_KNIGHT		67
#define RACE_DEEPSPAWN			68
#define RACE_DINOSAUR			69
#define RACE_DISPLACER_BEAST		70
#define RACE_DOG			71
#define RACE_DOLPHIN			72
#define RACE_DOPPLEGANGER		73
#define RACE_DRACOLICH			74
#define RACE_DRAGON			75
#define RACE_FAERIE_DRAGON		76
#define RACE_FIREDRAKE			77
#define RACE_PSEUDODRAGON		78
#define RACE_DRAGONNE			79
#define RACE_DRYAD			80
#define RACE_ELEMENTAL_AIR		81
#define RACE_ELEMENTAL_EARTH		82
#define RACE_ELEMENTAL_FIRE		83
#define RACE_ELEMENTAL_WATER		84
#define RACE_ELEPHANT			85
#define RACE_ETTERCAP			86
#define RACE_EYEWING			87
#define RACE_FEYR			88
#define RACE_FISH			89
#define RACE_FROG			90
#define RACE_FUNGUS			91
#define RACE_GALEB_DUHR			92
#define RACE_GARGOYLE			93
#define RACE_GENIE			94
#define RACE_GHOST			95
#define RACE_GHOUL			96
#define RACE_GIANT			97
#define RACE_GIBBERLING			98
#define RACE_GIFF			99
#define RACE_GITH			100
#define RACE_GITHYANKI			101
#define RACE_GITHZERAI			102
#define RACE_GNOLL			103
#define RACE_GOBLIN			104
#define RACE_GOLEM			105
#define RACE_GORGON			106
#define RACE_GRELL			107
#define RACE_GREMLIN			108
#define RACE_GRIFFON			109
#define RACE_GRIMLOCK			110
#define RACE_GRIPPLI			111
#define RACE_HAG			112
#define RACE_HARPY			113
#define RACE_HATORI			114
#define RACE_HAUNT			115
#define RACE_HELL_HOUND			116
#define RACE_HEUCUVA			117
#define RACE_HIPPOCAMPUS		118
#define RACE_HIPPOGRIFF			119
#define RACE_HOBGOBLIN			120
#define RACE_HOMONCULOUS		121
#define RACE_HOOK_HORROR		122
#define RACE_HORSE			123
#define RACE_HYDRA			124
#define RACE_IMP			125
#define RACE_INSECT			126
#define RACE_INTELLECT_DEVOURER		127
#define RACE_INVISIBLE_STALKER		128
#define RACE_IXITXACHITL		129
#define RACE_JACKELWERE			130
#define RACE_KENKU			131
#define RACE_KI_RIN			132
#define RACE_KIRRE			133
#define RACE_KOBOLD			134
#define RACE_KUO_TOA			135
#define RACE_LAMIA			136
#define RACE_LAMMASU			137
#define RACE_LEECH			138
#define RACE_LEPRECHAUN			139
#define RACE_LEUCROTTA			140
#define RACE_LICH			141
#define RACE_LIVING_WALL		142
#define RACE_LIZARD			143
#define RACE_LIZARD_MAN			144
#define RACE_LOCATHAH			145
#define RACE_LURKER			146
#define RACE_LYCANTHROPE		147
#define RACE_MAMMAL			148
#define RACE_MANSCORPION		149
#define RACE_MANTICORE			150
#define RACE_MEDUSA			151
#define RACE_MEADAR			152
#define RACE_MERMAN			153
#define RACE_MIMIC			154
#define RACE_MIND_FLAYER		155
#define RACE_MINOTAUR			156
#define RACE_MIST			157
#define RACE_MOLD			158
#define RACE_MONGRELMAN			159
#define RACE_MORKOTH			160
#define RACE_MUCKDWELLER		161
#define RACE_MUDMAN			162
#define RACE_MUMMY			163
#define RACE_MYCONID			164
#define RACE_NAGA			165
#define RACE_NEOGI			166
#define RACE_NIGHTMARE			167
#define RACE_NYMPH			168
#define RACE_OCTOPUS			169
#define RACE_OGRE			170
#define RACE_OGRE_MAGE			171
#define RACE_SLIME			172
#define RACE_ORC			173
#define RACE_OTYUGH			174
#define RACE_OWLBEAR			175
#define RACE_PEGASUS			176
#define RACE_PERYTON			177
#define RACE_PHANTOM			178
#define RACE_PHOENIX			179
#define RACE_PIERCER			180
#define RACE_PLANT			181
#define RACE_POLTERGEIST		182
#define RACE_PUDDING			183
#define RACE_QUAGGOTH			184
#define RACE_RAKSHASA			185
#define RACE_RAT			186
#define RACE_REMORHAZ			187
#define RACE_REVENANT			188
#define RACE_ROC			189
#define RACE_ROPER			190
#define RACE_RUST_MONSTER		191
#define RACE_SAHUAGIN			192
#define RACE_SATYR			193
#define RACE_SCORPION			194
#define RACE_SEA_LION			195
#define RACE_SELKIE			196
#define RACE_SHADOW			197
#define RACE_SHEDU			198
#define RACE_SIRINE			199
#define RACE_SKELETON			200
#define RACE_SLAAD			201
#define RACE_SLUG			202
#define RACE_SNAKE			203
#define RACE_SPECTRE			204
#define RACE_SPHINX			205
#define RACE_SPIDER			206
#define RACE_SPRITE			207
#define RACE_SQUID			208
#define RACE_STIRGE			209
#define RACE_SU_MONSTER			210
#define RACE_SWANMAY			211
#define RACE_TABAXI			212
#define RACE_TAKO			213
#define RACE_TANARRI			214
#define RACE_TARRASQUE			215
#define RACE_TASLOI			216
#define RACE_THOUGHT_EATER		217
#define RACE_THRI_KREEN			218
#define RACE_TITAN			219
#define RACE_TOAD			220
#define RACE_TREANT			221
#define RACE_TRITON			222
#define RACE_TROGLODYTE			223
#define RACE_TROLL			224
#define RACE_UMBER_HULK			225
#define RACE_UNICORN			226
#define RACE_URCHIN			227
#define RACE_VAMPIRE			228
#define RACE_WEMIC			229
#define RACE_WHALE			230
#define RACE_WIGHT			231
#define RACE_WILL_O_WISP		232
#define RACE_WOLF			233
#define RACE_WOLFWERE			234
#define RACE_WORM			235
#define RACE_WRAITH			236
#define RACE_WYVERN			237
#define RACE_XORN			238
#define RACE_YETI			239
#define RACE_YAUN_TI			240
#define RACE_YUGOLOTH			241
#define RACE_ZARATAN			242
#define RACE_ZOMBIE			243

#define NUM_RACES 	     		244

/* Sex */
#define SEX_NEUTRAL   0
#define SEX_MALE      1
#define SEX_FEMALE    2

/* alignment */
#define ALIGN_NONE            0
#define ALIGN_LAWFUL_GOOD     1
#define ALIGN_NEUTRAL_GOOD    2
#define ALIGN_CHAOTIC_GOOD    3
#define ALIGN_LAWFUL_NEUTRAL  4
#define ALIGN_NEUTRAL_NEUTRAL 5
#define ALIGN_CHAOTIC_NEUTRAL 6
#define ALIGN_LAWFUL_EVIL     7
#define ALIGN_NEUTRAL_EVIL    8
#define ALIGN_CHAOTIC_EVIL    9

#define NUM_ALIGNMENT         10


/* these two work together to give us many possible positions. */
/* postures */
#define POS_PRONE       0
#define POS_KNEELING    1
#define POS_SITTING     2
#define POS_STANDING    3
#define NUM_POSITIONS	4

/* status */
#define STAT_DEAD       BIT_3
#define STAT_DYING      BIT_4
#define STAT_INCAP      BIT_5
#define STAT_STUNNED    STAT_INCAP
#define STAT_SLEEPING   BIT_6
#define STAT_RESTING    BIT_7
#define STAT_NORMAL     BIT_8
#define STAT_MASK       (BIT_9 - 4)

#define HIT_INCAP      -3	/* The hit level for incapacitation   */
#define HIT_MORTALLYW  -6	/* The hit level for mortally wound   */
#define HIT_DEAD       -11	/* The point you never want to get to */

/* For players : Prompt flags (16 bits max) */
#define PROMPT_NONE        (1 << 0)
#define PROMPT_HIT         (1 << 1)
#define PROMPT_MAX_HIT     (1 << 2)
#define PROMPT_TANK_COND   (1 << 3)
#define PROMPT_TANK_NAME   (1 << 4)
#define PROMPT_ENEMY       (1 << 5)
#define PROMPT_ENEMY_COND  (1 << 6)
#define PROMPT_VIS         (1 << 7)
#define PROMPT_TWOLINE     (1 << 8)
#define PROMPT_WARN	   (1 << 9)

/* Player flags: used by char_data.char_specials.act */


#define PLR_FROZEN	(1 << 2)	/* Player is frozen                       */
#define PLR_DONTSET     (1 << 3)	/* Don't EVER set (ISNPC bit)     */
#define PLR_WRITING	(1 << 4)	/* Player writing (board/mail/olc)        */
#define PLR_MAILING	(1 << 5)	/* Player is writing mail         */
#define PLR_CRASH	(1 << 6)	/* Player needs to be crash-saved */
#define PLR_SITEOK	(1 << 7)	/* Player has been site-cleared   */
#define PLR_NOSHOUT	(1 << 8)	/* Player not allowed to shout/goss       */
#define PLR_NOTITLE	(1 << 9)	/* Player not allowed to set title        */
#define PLR_DELETED	(1 << 10)	/* Player deleted - space reusable        */
#define PLR_LOADROOM	(1 << 11)	/* Player uses nonstandard loadroom       */
#define PLR_NOWIZLIST	(1 << 12)	/* Player shouldn't be on wizlist */
#define PLR_NODELETE	(1 << 13)	/* Player shouldn't be deleted    */
#define PLR_INVSTART	(1 << 14)	/* Player should enter game wizinvis      */
#define PLR_CRYO	(1 << 15)	/* Player is cryo-saved (purge prog)      */
#define PLR_AFK		(1 << 16)	/* Player is not near the computer        */

/* Mobile flags: used by char_data.char_specials.act */
#define MOB_SPEC         (1 << 0)	/* Mob has a callable spec-proc   */
#define MOB_SENTINEL     (1 << 1)	/* Mob should not move            */
#define MOB_SCAVENGER    (1 << 2)	/* Mob picks up stuff on the ground       */
#define MOB_ISNPC        (1 << 3)	/* (R) Automatically set on all Mobs      */
#define MOB_AWARE	 (1 << 4)	/* Mob can't be backstabbed               */
#define MOB_AGGRESSIVE   (1 << 5)	/* Mob hits players in the room   */
#define MOB_STAY_ZONE    (1 << 6)	/* Mob shouldn't wander out of zone       */
#define MOB_WIMPY        (1 << 7)	/* Mob flees if severely injured  */
#define MOB_AGGR_EVIL	 (1 << 8)	/* auto attack evil PC's          */
#define MOB_AGGR_GOOD	 (1 << 9)	/* auto attack good PC's          */
#define MOB_AGGR_NEUTRAL (1 << 10)	/* auto attack neutral PC's               */
#define MOB_MEMORY	 (1 << 11)	/* remember attackers if attacked */
#define MOB_HELPER	 (1 << 12)	/* attack PCs fighting other NPCs */
#define MOB_NOCHARM	 (1 << 13)	/* Mob can't be charmed           */
#define MOB_NOSUMMON	 (1 << 14)	/* Mob can't be summoned          */
#define MOB_NOSLEEP	 (1 << 15)	/* Mob can't be slept             */
#define MOB_NOBASH	 (1 << 16)	/* Mob can't be bashed (e.g. trees)       */
#define MOB_NOBLIND	 (1 << 17)	/* Mob can't be blinded           */
#define MOB_MOUNTABLE	 (1 << 18)	// Is the mob mountable? (DAK)

/* number of queues to use (reduces enqueue cost) */
#define NUM_EVENT_QUEUES    10

/* Preference flags: used by char_data.player_specials.pref */
#define PRF_PAGING      (1 << 0)	/* Prefer page_string or send_to? */
#define PRF_COMPACT     (1 << 1)	/* No extra CRLF pair before prompts      */
#define PRF_DEAF	(1 << 2)	/* Can't hear shouts                      */
#define PRF_NOTELL	(1 << 3)	/* Can't receive tells            */
#define PRF_ROOMFLAGS	(1 << 4)	/* Can see room flags (ROOM_x)    */
#define PRF_NOHASSLE	(1 << 5)	/* Aggr mobs won't attack         */
#define PRF_NOREPEAT	(1 << 6)	/* No repetition of comm commands */
#define PRF_HOLYLIGHT	(1 << 7)	/* Can see in dark                        */
#define PRF_NOWIZ	(1 << 8)	/* Can't hear wizline                     */
#define PRF_LOG1	(1 << 9)	/* On-line System Log (low bit)   */
#define PRF_LOG2	(1 << 10)	/* On-line System Log (high bit)  */
#define PRF_GUILDTALK   (1 << 11)	/* Can hear guild talk */
#define PRF_MUDFTP      (1 << 12) 	/* Use mudFTP transfer system.        */
#define NUM_PREF	13

/* Affect bits: used in char_data.char_specials.saved.affected_by */
/* WARNING: In the world files, NEVER set the bits marked "R" ("Reserved") */

#define NUM_AFF	24

/* Bitvector for 'affected_by'.  Also, used for object bitvectors -DCL */
#define AFF_BLIND             BIT_1
#define AFF_INVISIBLE         BIT_2
#define AFF_DETECT_ALIGN      BIT_3
#define AFF_DETECT_INVIS      BIT_4
#define AFF_HASTE             BIT_5
#define AFF_SENSE_LIFE        BIT_6
#define AFF_MINOR_GLOBE       BIT_7
#define AFF_TAMED   	      BIT_8
#define AFF_IDENTIFY          BIT_9
#define AFF_GROUP             BIT_10
#define AFF_SCRIBING	      BIT_11
#define AFF_WATERBREATH       BIT_12
#define AFF_CURSE             BIT_13
#define AFF_PROTECT_EVIL      BIT_14
#define AFF_POISON            BIT_15
#define AFF_DETECT_MAGIC      BIT_16
#define AFF_PROTECT_GOOD      BIT_17
#define AFF_SLEEP             BIT_18
#define AFF_WATERWALK	      BIT_19
#define AFF_SNEAK             BIT_20
#define AFF_HIDE              BIT_21
#define AFF_FEAR              BIT_22
#define AFF_CHARM             BIT_23
#define AFF_LORE              BIT_24
#define AFF_BARKSKIN          BIT_25
#define AFF_INFRAVISION       BIT_26
#define AFF_LEVITATE          BIT_27
#define AFF_FLY               BIT_28
#define AFF_NOTRACK	      BIT_29
#define AFF_PROT_FIRE         BIT_30
#define AFF_CAMPING           BIT_31
#define AFF_MEMORIZING	      BIT_32

/* affected_by2 */

#define AFF2_FIRESHIELD       BIT_1
#define AFF2_ULTRAVISION      BIT_2
#define AFF2_DETECT_EVIL      BIT_3
#define AFF2_DETECT_GOOD      BIT_4
#define AFF2_SLOW_POISON      BIT_5
#define AFF2_CHANGE_SELF      BIT_6
#define AFF2_PROT_COLD        BIT_7
#define AFF2_PROT_LIGHTNING   BIT_8
#define AFF2_MINOR_PARALYSIS  BIT_9
#define AFF2_MAJOR_PARALYSIS  BIT_10
#define AFF2_SLOW             BIT_11
#define AFF2_GLOBE            BIT_12
#define AFF2_PROT_GAS         BIT_13
#define AFF2_PROT_ACID        BIT_14
#define AFF2_POISONED         BIT_15
#define AFF2_COMPREHEND_LANG  BIT_16
#define AFF2_SILENCED         BIT_17
#define AFF2_MINOR_INVIS      BIT_18
#define AFF2_GAZE_REFLECTION  BIT_19
#define AFF2_STUNNED          BIT_20
#define AFF2_DROPPED_PRIM     BIT_21
#define AFF2_DROPPED_SECOND   BIT_22
#define AFF2_FUMBLING_PRIM    BIT_23
#define AFF2_FUMBLING_SECOND  BIT_24
#define AFF2_HOLDING_BREATH   BIT_25	/* Underwater */
#define AFF2_SHIELD           BIT_26
#define AFF2_IS_DROWNING      BIT_27	/* Underwater */
#define AFF2_PASSDOOR         BIT_28
#define AFF2_DRAINING         BIT_29
#define AFF2_CASTING          BIT_30
#define AFF2_SPIDER_CLIMB     BIT_31
#define AFF2_HUNTER           BIT_32

/* affected_by 3 */

#define AFF3_TENSORS_DISC       BIT_1
#define AFF3_TRACKING           BIT_2
#define AFF3_SINGING            BIT_3
#define AFF3_ALTER_SELF         BIT_4
#define AFF3_BLUR               BIT_5
#define AFF3_BLINK              BIT_6
#define AFF3_HOLD               BIT_7
#define AFF3_POLYMORPH          BIT_8
#define AFF3_NON_DETECTION      BIT_9
#define AFF3_SILVER             BIT_10	/* Char needs silver to dam  */
#define AFF3_PLUSONE            BIT_11	/* Char needs +1 to damage   */
#define AFF3_PLUSTWO            BIT_12	/* Char needs +2 to damage   */
#define AFF3_PLUSTHREE          BIT_13	/* Char needs +3 to damage   */
#define AFF3_PLUSFOUR           BIT_14	/* Char needs +4 to damage   */
#define AFF3_PLUSFIVE           BIT_15	/* Char needs +5 to damage   */
#define AFF3_ENLARGE            BIT_16
#define AFF3_REDUCE             BIT_17
#define AFF3_COVER              BIT_18
#define AFF3_FOUR_ARMS          BIT_19
#define AFF3_ANTI_MAGIC_SHELL   BIT_20
#define AFF3_TRUE_SIGHT         BIT_21
#define AFF3_COLDSHIELD         BIT_22
#define AFF3_MIND_BLANK         BIT_23
#define AFF3_SWIMMING           BIT_24
#define AFF3_SHAPE_CHANGE       BIT_25
#define AFF3_UNDERWATER         BIT_26
#define AFF3_TIME_STOP          BIT_27
#define AFF3_NECKBITING         BIT_28	/* gith mana regain action */
#define AFF3_ELEMENTAL_FORM     BIT_29
#define AFF3_PASS_WITHOUT_TRACE BIT_30
#define AFF3_DETECT_POISON      BIT_31
#define AFF3_FREE_ACTION        BIT_32

#define AFF4_LOOTER             BIT_1	/* Just looted someone, prevent rent */
#define AFF4_CARRY_DISEASE      BIT_2
#define AFF4_SACKING            BIT_3	/* sacking a guildhall */
#define AFF4_SENSE_FOLLOWER     BIT_4
#define AFF4_WIND_WALK          BIT_5
#define AFF4_CLAIR		BIT_6
#define AFF4_VAMPIRE_FORM       BIT_7
#define AFF4_NO_UNMORPH         BIT_8	/* can't return .. */
#define AFF4_FAERIE_FIRE        BIT_9
#define AFF4_FEINT		BIT_10
#define AFF4_GALLOP		BIT_11

#define AFF4_THROAT_CRUSH	BIT_13
#define AFF4_REGENERATION	BIT_14
#define AFF4_BEARHUG	        BIT_15
#define AFF4_GRAPPLE            BIT_16
#define AFF4_GRAPPLED           BIT_17

#define AFF4_WRAITHFORM         BIT_19



#define AFF4_KNOCKED_OUT        BIT_23
#define AFF4_BOUND              BIT_24

#define AFF4_STONE_SKIN         BIT_26

/* languages */
#define TALK_USING	0
#define TALK_COMMON	1
#define TALK_ELF	2
#define TALK_DWARF	3
#define TALK_GOBLIN	4
#define TALK_HALFLING	5
#define TALK_HOBGOBLIN	6
#define TALK_KOBOLD	7
#define TALK_LIZARDMAN	8
#define TALK_OGRE	9
#define TALK_ORC	10
#define TALK_GNOME	11
#define TALK_ANIMAL	12
#define TALK_MAGIC	13
#define TALK_PLANT	14

#define LAST_HEARD	15
#define LAST_TALK	15

/* Modes of connectedness: used by descriptor_data.state */
#define CON_PLAYING	 0	/* Playing - Nominal state        */
#define CON_CLOSE	 1	/* Disconnecting          */
#define CON_GET_NAME	 2	/* By what name ..?               */
#define CON_NAME_CNFRM	 3	/* Did I get that right, x?       */
#define CON_PASSWORD	 4	/* Password:                      */
#define CON_NEWPASSWD	 5	/* Give me a password for x       */
#define CON_CNFPASSWD	 6	/* Please retype password:        */
#define CON_RMOTD	 7	/* PRESS RETURN after MOTD        */
#define CON_MENU	 8	/* Your choice: (main menu)       */
#define CON_EXDESC	 9	/* Enter a new description:       */
#define CON_CHPWD_GETOLD 10	/* Changing passwd: get old       */
#define CON_CHPWD_GETNEW 11	/* Changing passwd: get new       */
#define CON_CHPWD_VRFY   12	/* Verify new password            */
#define CON_DELCNF1	 13	/* Delete confirmation 1  */
#define CON_DELCNF2	 14	/* Delete confirmation 2  */
#define CON_OEDIT	 15	/*. OLC mode - object edit     . */
#define CON_REDIT	 16	/*. OLC mode - room edit       . */
#define CON_ZEDIT	 17	/*. OLC mode - zone info edit  . */
#define CON_MEDIT	 18	/*. OLC mode - mobile edit     . */
#define CON_SEDIT	 19	/*. OLC mode - shop edit       . */
#define CON_GEDIT	 20	/*. OLC mode - guild edit      . */
#define CON_QEDIT	 21	/*. OLC mode - quest edit      . */
#define CON_HEDIT	 22	/*. OLC mode - helpfile edit   . */
#define CON_PEDIT	 23	/*. OLC mode - Player edit     . */
#define CON_AEDIT        24	/*. OLC mode - action edit     . */
#define CON_TEDIT	 25
#define CON_TERM         26
#define CON_FTP_COMMAND  27
#define CON_FTP_DATA     28
#define CON_FTP_AUTH     29
#define NUM_CON		30

/* Character equipment positions: used as index for char_data.equipment[] */
/* NOTE: Don't confuse these constants with the ITEM_ bitvectors
   which control the valid places you can wear a piece of equipment */
#define WEAR_BADGE      0
#define WEAR_HEAD       1
#define WEAR_FACE       2
#define WEAR_EYES       3
#define WEAR_EARRING_R  4
#define WEAR_EARRING_L  5
#define WEAR_NECK       6
#define WEAR_BODY       7
#define WEAR_ABOUT      8
#define WEAR_BACK       9
#define WEAR_ARMS      10
#define WEAR_WRIST_R   11
#define WEAR_WRIST_L   12
#define WEAR_FINGER_R  13
#define WEAR_FINGER_L  14
#define WEAR_HANDS     15
#define WEAR_WAIST     16
#define WEAR_ATTACH_1  17
#define WEAR_ATTACH_2  18
#define WEAR_ATTACH_3  19
#define WEAR_SHIELD    20
#define WEAR_WIELD     21
#define WEAR_WIELD2    22
#define WEAR_HOLD      23
#define WEAR_HOLD2     24
#define WEAR_LEGS      25
#define WEAR_FEET      26

#define NUM_WEARS      27	/* This must be the # of eq positions!! */
#define WEAR_LIGHT     -1

/* obj size */
#define ITEM_SIZE_NONE       0
#define ITEM_SIZE_TINY       1
#define ITEM_SIZE_SMALL      2
#define ITEM_SIZE_SM         3
#define ITEM_SIZE_MEDIUM     4
#define ITEM_SIZE_ML         5
#define ITEM_SIZE_LARGE      6
#define ITEM_SIZE_HUGE       7
#define ITEM_SIZE_GIANT      8
#define ITEM_SIZE_GARGANTUAN 9

#define ITEM_SIZE_MAGICAL    10

/* mob size */
#define SIZE_NONE       0
#define SIZE_TINY       1
#define SIZE_SMALL      2
#define SIZE_SM         3
#define SIZE_MEDIUM     4
#define SIZE_ML         5
#define SIZE_LARGE      6
#define SIZE_HUGE       7
#define SIZE_GIANT      8
#define SIZE_GARGANTUAN 9
#define SIZE_MIN        1
#define SIZE_MAX        9

/* object-related defines ******************************************* */


/* Item types: used by obj_data.obj_flags.type_flag */
#define ITEM_LIGHT      1	/* Item is a light source */
#define ITEM_SCROLL     2	/* Item is a scroll               */
#define ITEM_WAND       3	/* Item is a wand         */
#define ITEM_STAFF      4	/* Item is a staff                */
#define ITEM_WEAPON     5	/* Item is a weapon               */
#define ITEM_FIREWEAPON 6	/* Unimplemented          */
#define ITEM_MISSILE    7	/* Unimplemented          */
#define ITEM_TREASURE   8	/* Item is a treasure, not gold   */
#define ITEM_ARMOR      9	/* Item is armor          */
#define ITEM_POTION    10	/* Item is a potion               */
#define ITEM_WORN      11	/* Unimplemented          */
#define ITEM_OTHER     12	/* Misc object                    */
#define ITEM_TRASH     13	/* Trash - shopkeeps won't buy    */
#define ITEM_TRAP      14	/* Unimplemented          */
#define ITEM_CONTAINER 15	/* Item is a container            */
#define ITEM_NOTE      16	/* Item is note           */
#define ITEM_DRINKCON  17	/* Item is a drink container      */
#define ITEM_KEY       18	/* Item is a key          */
#define ITEM_FOOD      19	/* Item is food                   */
#define ITEM_MONEY     20	/* Item is money (gold)           */
#define ITEM_PEN       21	/* Item is a pen          */
#define ITEM_BOAT      22	/* Item is a boat         */
#define ITEM_FOUNTAIN  23
#define ITEM_BOARD     24	/* Item is a board                */
#define ITEM_BOOK      25	/* Magical book usually           */
#define ITEM_WALL      26	/* Wall of force, etc */
#define ITEM_CORPSE    27	/* internal use only, do NOT assign this type! */
#define ITEM_TELEPORT  28	/* item can be used to teleport */
#define ITEM_TIMER     29	/* used chiefly to load/activate traps */
#define ITEM_VEHICLE   30	/* Like ships, but can 'follow' mobs (carraige) */
#define ITEM_SHIP      31	/* item which represents a sea-going vessel */
#define ITEM_SWITCH    32	/* item is a trigger for a switch proc */
#define ITEM_QUIVER    33	/* container for MISSILEs only */
#define ITEM_PICK      34	/* lockpicks */
#define ITEM_INSTRUMENT 35	/* bard's instruments */
#define ITEM_FURNITURE 36	/* Genuine magetype spellbook */
#define ITEM_STORAGE   37	/* like a container, but saves itself */
#define ITEM_SCABBARD  38	/* weapon scabbard */
#define ITEM_SHIELD    39	/* dedicated type for shields */
#define ITEM_TROOP     40	/* troop item type */
#define ITEM_HOLY_SYMBOL 41	/* troop item type */
#define ITEM_PIT       42	/* Like item_teleport, but enter not req. */
#define ITEM_DOOR	43

#define PC_CORPSE       BIT_1
#define NPC_CORPSE      BIT_2
#define MISSING_SKULL   BIT_3
#define MISSING_SCALP   BIT_4
#define MISSING_FACE    BIT_5
#define MISSING_EYES    BIT_6
#define MISSING_EARS    BIT_7
#define MISSING_TONGUE  BIT_8
#define MISSING_BOWELS  BIT_9
#define MISSING_ARMS    BIT_10
#define MISSING_LEGS    BIT_11
#define HUMANOID_CORPSE BIT_16

/* Take/Wear flags: used by obj_data.obj_flags.wear_flags */
#define ITEM_TAKE		(1 << 0)	/* Item can be takes              */
#define ITEM_WEAR_TAKE          (1 << 0)
#define ITEM_WEAR_FINGER	(1 << 1)	/* Can be worn on finger  */
#define ITEM_WEAR_NECK		(1 << 2)	/* Can be worn around neck        */
#define ITEM_WEAR_BODY		(1 << 3)	/* Can be worn on body    */
#define ITEM_WEAR_HEAD		(1 << 4)	/* Can be worn on head    */
#define ITEM_WEAR_LEGS		(1 << 5)	/* Can be worn on legs    */
#define ITEM_WEAR_FEET		(1 << 6)	/* Can be worn on feet    */
#define ITEM_WEAR_HANDS		(1 << 7)	/* Can be worn on hands   */
#define ITEM_WEAR_ARMS		(1 << 8)	/* Can be worn on arms    */
#define ITEM_WEAR_SHIELD	(1 << 9)	/* Can be used as a shield        */
#define ITEM_WEAR_ABOUT		(1 << 10)	/* Can be worn about body         */
#define ITEM_WEAR_WAIST 	(1 << 11)	/* Can be worn around waist       */
#define ITEM_WEAR_WRIST		(1 << 12)	/* Can be worn on wrist   */
#define ITEM_WEAR_WIELD		(1 << 13)	/* Can be wielded         */
#define ITEM_WEAR_HOLD		(1 << 14)	/* Can be held            */
#define ITEM_LIGHT_SOURCE       (1 << 15)
#define ITEM_WEAR_EYES          (1 << 16)	/* Can be worn on eyes    */
#define ITEM_WEAR_FACE          (1 << 17)	/* Can be worn on face    */
#define ITEM_WEAR_EARRING       (1 << 18)	/* Can be worn on ears    */
#define ITEM_GUILD_INSIGNIA     (1 << 19)	/* Can be worn as badge   */
#define ITEM_WEAR_BACK          (1 << 20)	/* Can be worn on back    */
#define ITEM_ATTACH_BELT        (1 << 21)	/* Can be attach to belt  */


/* Bitvector for 'extra_flags' */

#define ITEM_GLOW          BIT_1
#define ITEM_NOSHOW        BIT_2	/* item is _never_ shown        */
#define ITEM_BURIED        BIT_3
#define ITEM_NOSELL        BIT_4	/* shopkeepers won't buy it     */
#define ITEM_EVIL          BIT_5
#define ITEM_INVISIBLE     BIT_6
#define ITEM_MAGIC         BIT_7
#define ITEM_NODROP        BIT_8
#define ITEM_BLESS         BIT_9
#define ITEM_ANTI_GOOD     BIT_10	/* not usable by good people    */
#define ITEM_ANTI_EVIL     BIT_11	/* not usable by evil people    */
#define ITEM_ANTI_NEUTRAL  BIT_12	/* not usable by neutral people */
#define ITEM_SECRET        BIT_13
#define ITEM_FLOAT         BIT_14
#define ITEM_NOBURN        BIT_15	/* can't be destroyed with dragon breath */
#define ITEM_NOLOCATE      BIT_16	/* Item cannot be located       */
#define ITEM_NOIDENTIFY    BIT_17	/* Item cannot be identified    */
#define ITEM_NOSUMMON      BIT_18	/* if in inventory cannot be summoned */
#define ITEM_LIT           BIT_19	/* Item has a light spell cast on it */
#define ITEM_TRANSIENT     BIT_20	/* Item which dissolves when dropped */
#define ITEM_NOSLEEP       BIT_21	/* If in inventory, cannot be slept */
#define ITEM_NOCHARM       BIT_22	/* If in inventory, cannot be charmed */
#define ITEM_TWOHANDS      BIT_23	/* item requires two hands to hold/wield */
#define ITEM_NORENT        BIT_24	/* item cannot be rented */
#define ITEM_GOOD          BIT_25
#define ITEM_CONCEALED     BIT_26	/* other item hides it, not same as secret */
#define ITEM_LEVITATES     BIT_27
#define ITEM_ONEORTWOHANDS BIT_28	/* item requires two hands to hold/wield */
#define ITEM_WHOLE_BODY    BIT_30
#define ITEM_WHOLE_HEAD    BIT_31
#define ITEM_WAS_DISARMED  BIT_32	/* if disarmed, re-arm in perform_violence */

#define ITEM2_SILVER       BIT_1	/* Item harm AFF_SILVER         */
#define ITEM2_PLUSONE      BIT_2	/* Item harm upto AFF_PLUSONE   */
#define ITEM2_PLUSTWO      BIT_3	/* Item harm upto AFF_PLUSTWO   */
#define ITEM2_PLUSTHREE    BIT_4	/* Item harm upto AFF_PLUSTHREE */
#define ITEM2_PLUSFOUR     BIT_5	/* Item harm upto AFF_PLUSFOUR  */
#define ITEM2_PLUSFIVE     BIT_6	/* Item harm upto AFF_PLUSFIVE  */
#define ITEM2_RETURNING    BIT_7	/* Boomerang item, returns      */
#define ITEM2_CAN_THROW1   BIT_8	/* Item can be thrown 1 room    */
#define ITEM2_CAN_THROW2   BIT_9	/* Item can be thrown 2 rooms   */
#define ITEM2_REMOVE_2HAND BIT_10	/* Needs changing back to single*/
#define ITEM2_ENLARGE      BIT_17	/* item been enlarge */
#define ITEM2_REDUCE       BIT_18	/* item been reduce  */

/* Bitvector for 'anti_flags' */

#define ITEM_ALLOW_ALL         BIT_1
#define ITEM_ALLOW_CLERIC      BIT_2
#define ITEM_ALLOW_DRUID       BIT_3
#define ITEM_ALLOW_FIGHTER     BIT_4
#define ITEM_ALLOW_PALADIN     BIT_5
#define ITEM_ALLOW_RANGER      BIT_6
#define ITEM_ALLOW_MAGIC_USER  BIT_7
#define ITEM_ALLOW_ILLUSIONIST BIT_8
#define ITEM_ALLOW_THIEF       BIT_9
#define ITEM_ALLOW_BARD        BIT_10

#define MONEY_COPPER		0
#define MONEY_SILVER		1
#define MONEY_ELECTRUM		2
#define MONEY_GOLD		3
#define MONEY_PLATINUM		4


/* Modifier constants used with obj affects ('A' fields) */
#define APPLY_NONE              0	/* No effect                      */
#define APPLY_STR               1	/* Apply to strength              */
#define APPLY_DEX               2	/* Apply to dexterity             */
#define APPLY_INT               3	/* Apply to constitution  */
#define APPLY_WIS               4	/* Apply to wisdom                */
#define APPLY_CON               5	/* Apply to constitution  */
#define APPLY_CHA		6	/* Apply to charisma              */
#define APPLY_CLASS             7	/* Reserved                       */
#define APPLY_LEVEL             8	/* Reserved                       */
#define APPLY_AGE               9	/* Apply to age                   */
#define APPLY_CHAR_WEIGHT      10	/* Apply to weight                */
#define APPLY_CHAR_HEIGHT      11	/* Apply to height                */
#define APPLY_HIT              12	/* Apply to max hit points        */
#define APPLY_MAGIC_RES        13	/* Reserved                       */
#define APPLY_EXP              14	/* Reserved                       */
#define APPLY_AC               15	/* Apply to Armor Class           */
#define APPLY_HITROLL          16	/* Apply to hitroll               */
#define APPLY_DAMROLL          17	/* Apply to damage roll           */
#define APPLY_SAVING_PARA      18	/* Apply to save throw: paralz    */
#define APPLY_SAVING_ROD       19	/* Apply to save throw: rods      */
#define APPLY_SAVING_PETRI     20	/* Apply to save throw: petrif    */
#define APPLY_SAVING_BREATH    21	/* Apply to save throw: breath    */
#define APPLY_SAVING_SPELL     22	/* Apply to save throw: spells    */
#define APPLY_SAVING_ALL       23	/* Apply to all save throw        */
#define APPLY_MAX_STR          24	/* Change str to number, 26=18/100 */
#define APPLY_HEARING	       25	/* Apply to hearing checks	  */
#define APPLY_VISION	       26	/* Apply to vision checks	  */

/* Container flags - value[1] */
#define CONT_CLOSEABLE      (1 << 0)	/* Container can be closed        */
#define CONT_PICKPROOF      (1 << 1)	/* Container is pickproof */
#define CONT_CLOSED         (1 << 2)	/* Container is closed            */
#define CONT_LOCKED         (1 << 3)	/* Container is locked            */

/* Some different kind of liquids for use in values of drink containers */
#define LIQ_WATER      0
#define LIQ_BEER       1
#define LIQ_WINE       2
#define LIQ_ALE        3
#define LIQ_DARKALE    4
#define LIQ_WHISKY     5
#define LIQ_LEMONADE   6
#define LIQ_FIREBRT    7
#define LIQ_LOCALSPC   8
#define LIQ_SLIME      9
#define LIQ_MILK       10
#define LIQ_TEA        11
#define LIQ_COFFE      12
#define LIQ_BLOOD      13
#define LIQ_SALTWATER  14
#define LIQ_CLEARWATER 15

/* Basic furniture */
#define FURN_THRONE	1
#define FURN_CHAIR	2
#define FURN_TABLE	3
#define FURN_BOOKCASE	4
#define FURN_BED	5
#define FURN_COUNTER	6
#define FURN_DESK	7
/* be sure to update constants.c and utils.h */
#define NUM_FURN_TYPES	8


/* other miscellaneous defines ****************************************** */


/* Player conditions */
#define DRUNK        0
#define FULL         1
#define THIRST       2


/* Sun state */
#define SUN_DARK	0
#define SUN_RISE	1
#define SUN_LIGHT	2
#define SUN_SET		3


/* Sky conditions */
#define SKY_CLOUDLESS	0
#define SKY_CLOUDY	1
#define SKY_RAINING	2
#define SKY_LIGHTNING	3


/* Rent codes */
#define RENT_UNDEF      0
#define RENT_CRASH      1
#define RENT_RENTED     2
#define RENT_CRYO       3
#define RENT_FORCED     4
#define RENT_TIMEDOUT   5

//Target locations
#define LOCATION_VITALS 0
#define LOCATION_BRAIN 1
#define LOCATION_FACE 2
#define LOCATION_SHIELD_ARM 3
#define LOCATION_SHIELD_HAND 4
#define LOCATION_WEAPON_HAND 5
#define LOCATION_WEAPON_ARM 6
#define LOCATION_TORSO 7
#define LOCATION_RIGHT_LEG 8
#define LOCATION_LEFT_LEG 9
#define LOCATION_RIGHT_FOOT 10
#define LOCATION_LEFT_FOOT 11
#define NUMBER_LOCATIONS 12 //last + 1
#define LOCATION_ALL 12 //same as number_locations

//Style types
#define STYLE_AGGRESSIVE 0
#define STYLE_NORMAL 1
#define STYLE_DEFENSIVE 2

//Weapon Strike Types
#define STK_UNDEFINED 	0
#define STK_CRUSH 	1
#define STK_IMPALE 	2
#define STK_CUT 	3
#define STK_CUT_IMP	4
#define STK_IMP_CSH	5
#define STK_CUT_CSH	6

//Weapon Definitions
#define WEAPON_UNDEFINED	0
#define WEAPON_BATTLE_AXE	1
#define WEAPON_BOW		2
#define WEAPON_CLUB		3
#define WEAPON_CROSSBOW		4
#define WEAPON_DAGGER		5
#define WEAPON_DART		6
#define WEAPON_FLAIL		7
#define WEAPON_MACE		8
#define WEAPON_PICK		9
#define WEAPON_HAMMER		10
#define WEAPON_HAND_AXE		11
#define WEAPON_HARPOON		12
#define WEAPON_JAVELIN		13
#define WEAPON_KNIFE		14
#define WEAPON_LANCE		15
#define WEAPON_MANCATCHER	16
#define WEAPON_MORNING_STAR	17
#define WEAPON_POLEARM		18
#define WEAPON_STAFF		19
#define WEAPON_SCOURGE		20
#define WEAPON_SICKLE		21
#define WEAPON_SLING		22
#define WEAPON_SPEAR		23
#define WEAPON_STAFF_SLING	24
#define WEAPON_BASTARD_SWORD	25
#define WEAPON_BROAD_SWORD	26
#define WEAPON_KHOPESH		27
#define WEAPON_LONG_SWORD	28
#define WEAPON_SHORT_SWORD	29
#define WEAPON_TWO_HANDED_SWORD	30
#define WEAPON_TRIDENT		31
#define WEAPON_WHIP		32
#define WEAPON_RAPIER		33
#define WEAPON_SABER		34

//which is dominant hand
#define HAND_RIGHT 	0
#define HAND_LEFT	1
#define HAND_BOTH	2

/* other #defined constants ********************************************* */

/*
 * **DO**NOT** blindly change the number of levels in your MUD merely by
 * changing these numbers and without changing the rest of the code to match.
 * Other changes throughout the code are required.  See coding.doc for
 * details.
 *
 * LVL_IMPL should always be the HIGHEST possible immortal level, and
 * LVL_IMMORT should always be the LOWEST immortal level.  The number of
 * mortal levels will always be LVL_IMMORT - 1.
 */
#define LVL_IMPL	34
#define LVL_GRGOD	33
#define LVL_GOD		32
#define LVL_IMMORT	31

/* Level of the 'freeze' command */
#define LVL_FREEZE	LVL_GRGOD

#define NUM_OF_DIRS	10	/* number of directions in a room (nsewud) */

#define OPT_USEC	100000	/* 10 passes per second */
#define PASSES_PER_SEC	(1000000 / OPT_USEC)
#define RL_SEC		* PASSES_PER_SEC

#define PULSE_ZONE      (10 RL_SEC)
#define PULSE_MOBILE    (1 RL_SEC)
#define PULSE_SPEC 	(5 RL_SEC)
#define PULSE_VIOLENCE  (PASSES_PER_SEC / 5) /* every .2 secs */
#define PULSE_PATH	(10 RL_SEC)	/* oh sure, you could make it smaller */
#define MOBILE_PERCENT  10	/* Do 1 in 10 of specials per mobile pulse. */

/* Variables for the output buffering system */
#define MAX_SOCK_BUF            (12 * 1024)	/* Size of kernel's sock buf   */
#define MAX_PROMPT_LENGTH       256	/* Max length of prompt        */
#define GARBAGE_SPACE		32	/* Space for **OVERFLOW** etc  */
#define SMALL_BUFSIZE		1024	/* Static output buffer size   */
/* Max amount of output that can be buffered */
#define LARGE_BUFSIZE	   (MAX_SOCK_BUF - GARBAGE_SPACE - MAX_PROMPT_LENGTH)

#define MAX_STRING_LENGTH	24576	/* 307+ 80 character lines */
#define MAX_INPUT_LENGTH	512	/* Max length per *line* of input */
#define MAX_RAW_INPUT_LENGTH	1024	/* Max size of *raw* input */
#define MAX_MESSAGES		60
#define MAX_NAME_LENGTH		20	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_PWD_LENGTH		10	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_TITLE_LENGTH	80	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_SHORTDESC_LENGTH  	80	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_INTRO		50	/* Used in char_file_u *DO*NOT*CHANGE* */
#define HOST_LENGTH		30	/* Used in char_file_u *DO*NOT*CHANGE* */
#define EXDSCR_LENGTH		240	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_TONGUE		50	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_SKILLS		500	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_SPELLS		520	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_CIRCLE		9
#define MAX_AFFECT		32	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_OBJ_AFFECT		6	/* Used in obj_file_elem *DO*NOT*CHANGE* */
#define POOF_LENGTH		256
#define MAX_COMPLETED_QUESTS	1024

/**********************************************************************
* Structures                                                          *
**********************************************************************/


typedef signed char sbyte;
typedef unsigned char ubyte;
typedef signed short int sh_int;
typedef unsigned short int ush_int;
typedef char bool;
typedef enum { FTP_NORMAL, FTP_PUSH, FTP_PUSH_WAIT } ftp_mode;

#ifndef CIRCLE_WINDOWS
typedef char byte;
#endif

typedef int room_vnum;		/* A room's vnum type */
typedef int obj_vnum;		/* An object's vnum type */
typedef int mob_vnum;		/* A mob's vnum type */

typedef int room_rnum;		/* A room's real (internel) number type */
typedef int obj_rnum;		/* An object's real (internal) num type */
typedef int mob_rnum;		/* A mobile's real (internal) num type */

/* IH 05-Oct-98 Moved queue definition to queue.h */
struct q_element {
  void *data;
  long key;
  struct q_element *prev, *next;
};

struct event {
  EVENTFUNC(*func);
  void *event_obj;
  struct q_element *q_el;
};

/* Fighting event struct used in fighting engine */
struct fight_event_data {
  struct char_data *ch, *vict;
};

/* Extra description: used in objects, mobiles, and rooms */
struct extra_descr_data {
  char *keyword;		/* Keyword in look/examine          */
  char *description;		/* What to see                      */
  struct extra_descr_data *next;	/* Next in list                     */
};


/* object-related structures ***************************************** */


/* object flags; used in obj_data */
struct obj_flag_data {
  int value[8];			/* Values of the item (see list)    */
  byte type_flag;		/* Type of item                     */
  ulong wear_flags;		/* Where you can wear it            */
  ulong extra_flags;		/* If it hums, glows, etc.          */
  ulong anti_flags;		/* Specific anti-class and race     */
  ulong extra2_flags;		/* Range weapon-related flags       */
  byte size;			/* size of object (for race)        */
  byte space;			/* size of object (volume)          */
  sh_int race;
  sh_int condition;		/* items condition or level         */
  sh_int status;		/* brittle, melted, etc.            */
  sh_int material;		/* what its made of                 */
  sh_int craftsmanship;		/* how well made item is            */

  float weight;			/* Weight what else                 */
  int cost;			/* Value when sold (gp.)            */
  int orig_vnum;		/* Original prototypes vnum	    */
  int timer;			/* Timer for object                 */
  ulong bitvector;		/* To set chars bits                */
  ulong bitvector2;		/* 2nd 32 bits                      */
  ulong bitvector3;
  ulong bitvector4;

  int trap_eff;			/* trap effect type                 */
  int trap_dam;			/* trap damage type                 */
  sh_int trap_charge;		/* trap charges                     */
  sh_int trap_level;

  sh_int z_cord;
  sh_int x_cord;
  sh_int y_cord;
};


/* Used in obj_file_elem *DO*NOT*CHANGE* */
struct obj_affected_type {
  byte location;		/* Which ability to change (APPLY_XXX) */
  sbyte modifier;		/* How much it changes by              */
};


/* ================== Memory Structure for Objects ================== */
struct obj_data {
  obj_vnum item_number;		/* Where in data-base                   */
  long id;			/* Unique identifier                    */
  room_rnum in_room;		/* In what room -1 when conta/carr      */

  struct obj_flag_data obj_flags;	/* Object information               */
  struct obj_affected_type affected[MAX_OBJ_AFFECT];	/* affects */

  char *name;			/* Title of object :get etc.        */
  char *description;		/* When in room                     */
  char *short_description;	/* when worn/carry/in cont.         */
  char *action_description;	/* What to write when used          */
  struct extra_descr_data *ex_description;	/* extra descriptions     */
  struct char_data *carried_by;	/* Carried by :NULL in room/conta   */
  struct char_data *people;     /* List of NPC / PC in object       */
  struct char_data *worn_by;	/* Worn by?                         */
  sh_int worn_on;		/* Worn where?                      */
  
  struct char_data *orig_char;	/* polymorph object spell	    */
  long idnum_owner;

  struct obj_data *in_obj;	/* In what object NULL when none    */
  struct obj_data *contains;	/* Contains objects                 */

  struct trig_proto_list *proto_script; /* list of default triggers  */
  struct script_data *script;    /* script info for the object       */

  struct obj_data *next_content;	/* For 'contains' lists             */
  struct obj_data *next;	/* For the object list              */
};

/* ======================================================================= */


/* ====================== File Element for Objects ======================= */
/*                 BEWARE: Changing it will ruin rent files                */
struct obj_file_elem {
  obj_vnum item_number;

  sh_int locate;		/* that's the (1+)wear-location (when equipped) or */
  /* (20+)index in obj file (if it's in a container) BK */
  int value[8];
  ulong extra_flags;
  ulong extra2_flags;
  ulong anti_flags;

  byte size;			/* size of object (for race)        */
  byte space;			/* size of object (volume)          */
  sh_int race;

  sh_int condition;		/* items condition or level         */
  sh_int status;		/* brittle, melted, etc.            */
  sh_int material;		/* what its made of                 */
  sh_int craftsmanship;		/* how well made item is            */

  long idnum_owner;

  float weight;
  int cost;
  int timer;
  ulong bitvector;
  ulong bitvector2;
  ulong bitvector3;
  ulong bitvector4;
  struct obj_affected_type affected[MAX_OBJ_AFFECT];
};


/* header block for rent files.  BEWARE: Changing it will ruin rent files  */
struct rent_info {
  int time;
  int rentcode;
  int net_cost_per_diem;
  int nitems;
};

/* ======================================================================= */


/* room-related structures *********************************************** */


struct room_direction_data {
  char *general_description;	/* When look DIR.                   */

  char *keyword;		/* for open/close                       */

  sh_int exit_info;		/* Exit info                            */
  obj_vnum key;			/* Key's number (-1 for no key)         */
  room_rnum to_room;		/* Where direction leads (NOWHERE)      */
  sh_int hitpoints;		/* For damaging them			*/
  sh_int x_cord;		/* Heighth of door from floor           */
  sh_int y_cord;
  sh_int z_cord;
};

/* this is done so I can allocate/deallocate on the fly */
struct map_data {
  sh_int map_grid[51][51];
};

/* ================== Memory Structure for room ======================= */
struct room_data {
  room_vnum number;		/* Rooms number (vnum)                */
  long id;			/* Unique identifier                  */
  sh_int zone;			/* Room zone (for resetting)          */
  int sector_type;		/* sector type (move/hide)            */
  char *name;			/* Rooms name 'You are ...'           */
  char *description;		/* Shown when entered                 */
  struct extra_descr_data *ex_description;	/* for examine/look       */
  struct room_direction_data *dir_option[NUM_OF_DIRS];	/* Directions */
  int room_flags;		/* DEATH,DARK ... etc                 */
  int resources;
  int shape;			/* circular, square, etc              */
  sh_int x_size;		/* N/S measurement                    */
  sh_int y_size;		/* E/W measurement                    */
  sh_int z_size;
  sh_int kingdom_num;
  sh_int kingdom_type;
  sh_int current_speed;
  sh_int current_direction;
  sh_int chance_fall;
  struct map_data *map;		/* holder for the grid			*/
  int map_specials;		/* display items like columns, rivers */
  byte light;			/* Number of lightsources in room     */
   SPECIAL(*func);

  struct trig_proto_list *proto_script; /* list of default triggers  */
  struct script_data *script;  /* script info for the object         */ 

  struct obj_data *contents;	/* List of items in room              */
  struct char_data *people;	/* List of NPC / PC in room           */
};

/* ====================================================================== */


/* char-related structures *********************************************** */


/* memory structure for characters */
struct memory_rec_struct {
  long id;
  struct memory_rec_struct *next;
};

typedef struct memory_rec_struct memory_rec;



/* This structure is purely intended to be an easy way to transfer */
/* and return information about time (real or mudwise).            */
struct time_info_data {
  int hours, day, month, minutes;
  sh_int year;
};


/* These data contain information about a players time data */
struct time_data {
  time_t birth;			/* This represents the characters age                */
  time_t logon;			/* Time of the last logon (used to calculate played) */
  int played;			/* This is the total accumulated time played in secs */
};


/* general player-related info, usually PC's and NPC's */
struct char_player_data {
  char passwd[MAX_PWD_LENGTH + 1];	/* character's password      */
  char *name;			/* PC / NPC s name (kill ...  )         */
  char *short_descr;		/* for NPC 'actions'                    */
  char *long_descr;		/* for 'look'                           */
  char *description;		/* Extra descriptions                   */
  char *title;			/* PC / NPC's title                     */
  byte sex;			/* PC / NPC's sex                       */
  byte class;			/* PC / NPC's class                     */
  sh_int race;			/* PC / NPC's race                      */
  byte level;			/* PC / NPC's level                     */
  byte size;			/* PC / NPC's size                      */
  int hometown;			/* PC s Hometown (zone)                 */
  int birthplace;		/* birth room                           */
  int orig_birthplace;		/* original birth room                 */
  struct time_data time;	/* PC's AGE in days                 */
  ubyte weight;			/* PC / NPC's weight                    */
  ubyte height;			/* PC / NPC's height                    */
};

struct player_disguise_data {
  bool active_pc;		/* is he disguise                       */
  bool active_npc;
  char *name;			/* PC name                              */
  int class;			/* class                                */
  sh_int race;			/* race                                 */
  ubyte level;			/* level                                */
  char *title;			/* title                                */
};

/* Char's abilities.  Used in char_file_u *DO*NOT*CHANGE* */
struct char_ability_data {
  sbyte str;
  sbyte str_add;		/* 000 - 100 if strength 18             */
  sbyte intel;
  sbyte wis;
  sbyte dex;
  sbyte con;
  sbyte cha;
};

/*body part hp*/
struct char_body_hitpoints {
  int head;
  int shield_arm;
  int shield_hand;
  int weapon_hand;
  int weapon_arm;
  int torso;
  int right_leg;
  int left_leg;
  int right_foot;
  int left_foot;
};

/* Char's points.  Used in char_file_u *DO*NOT*CHANGE* */
struct char_point_data {
  sh_int hit;
  sh_int max_hit;		/* Max hit for PC/NPC                      */

  struct char_body_hitpoints body_points;

  sh_int vitality;
  sh_int max_vitality;		/*How long can you go without falling asleep */

  sh_int armor;			/* Internal -100..100, external -10..10 AC */
  int gold;			/* temp holder of gold, changed to obj later */
  int exp;			/* The experience of the player            */

  sbyte hitroll;		/* Any bonus or penalty to the hit roll    */
  sbyte damroll;		/* Any bonus or penalty to the damage roll */
};

/* 
 * char_special_data_saved: specials which both a PC and an NPC have in
 * common, but which must be saved to the playerfile for PC's.
 *
 * WARNING:  Do not change this structure.  Doing so will ruin the
 * playerfile.  If you want to add to the playerfile, use the spares
 * in player_special_data.
 */
struct char_special_data_saved {
  int alignment;		/*   */
  long idnum;			/* player's idnum; -1 for mobiles       */
  long act;			/* act flag for NPC's; player flag for PC's */
  byte spells[MAX_SPELLS + 1];	/* array of skills plus skill 0         */
  byte skills[MAX_SKILLS + 1];	/* Skills */
  ulong granted_one;		/* commands granted                     */
  ulong granted_two;		/* commands granted                     */
  ulong affected_by;		/* Bitvector for spells/skills affected by */
  ulong affected_by2;		/* Bitvector for spells/skills affected by */
  ulong affected_by3;
  ulong affected_by4;
  byte disease_type[5];
  byte disease_dura[5];
  byte weapon_prof;		/* weapon proficiency */
  byte non_weapon_prof;		/* non-weapon proficiency */
  byte high_level;
  int thief_skill;

  byte specialist;		/* if mage is specialist */
  ulong mage_school;		/* list of mage scholl available to player */
  ulong priest_sphere_major;	/* list of priest major sphere available to player */
  ulong priest_sphere_minor;	/* list of priest minor sphere available to player */
  int priest_deity;		/* priest deity */

  sh_int apply_saving_throw[5];	/* Saving throw (Bonuses)              */

};

/* Special playing constants shared by PCs and NPCs which aren't in pfile */
struct char_special_data {
  struct char_data *fighting;	/* Opponent                             */
  struct char_data *hunting;	/* Char hunted by this char             */
  struct event *fevent;    	/* Event for fighting                   */
  struct char_data *riding;	/* Who are they riding? 		*/
  struct char_data *ridden_by;	/* Who is riding them? 			*/
  struct obj_data *vehicle;	/* cart, wagon			 */
  struct obj_data *furniture;   /* What they are sitting, sleeping on   */
  struct obj_data *polymorph;	/* Object they've polymorphed into	*/

  byte attacks_left;		/* How many more attacks to figure in
				   subsequent hit calls                 */
  int position;			/* Standing, sleeping, etc.   */

  byte magic_resistance;	/* magic resiatnce */

  int carry_weight;		/* Carried weight                       */
  byte carry_items;		/* Number of items carried              */
  int timer;			/* Timer for update                     */
  int target_room;
  int target_location;  	/*where are we targetting? */
  int style; 			/*aggressive, passive, normal*/
  byte s_o_t; 			/*slash or thrust :P*/
  struct spell_data *spell_mem_list;
  struct event *action;		/* event for action which takes time    */
  struct char_special_data_saved saved;		/* constants saved in plrfile  */

};


/*
 *  If you want to add new values to the playerfile, do it here.  DO NOT
 * ADD, DELETE OR MOVE ANY OF THE VARIABLES - doing so will change the
 * size of the structure and ruin the playerfile.  However, you can change
 * the names of the spares to something more meaningful, and then use them
 * in your new code.  They will automatically be transferred from the
 * playerfile into memory when players log in.
 */
struct player_special_data_saved {
  bool talks[MAX_TONGUE];	/* PC s Tongues 0 for NPC               */
  int wimp_level;		/* Below this # of hit points, flee!    */
  byte freeze_level;		/* Level of god who froze char, if any  */
  sh_int invis_level;		/* level of invisibility                */
  room_vnum load_room;		/* Which room to place char in          */
  long pref;			/* preference flags for PC's.           */
  ubyte bad_pws;		/* number of bad password attemps       */
  sbyte conditions[3];		/* Drunk, full, thirsty                 */
  char poofin[POOF_LENGTH + 1];
  char poofout[POOF_LENGTH + 1];
  long int introd_list[MAX_INTRO];
  unsigned long int introd_times[MAX_INTRO];
  char *last_host;
  int known_rooms[25];

  /* spares below for future expansion.  You can change the names from
     'sparen' to something meaningful, but don't change the order.  */

  ubyte angle_type;
  ubyte facing;
  ubyte dominant_hand;
  ubyte spare3;
  ubyte spare4;
  ubyte spare5;
  int spare6;
  int olc_zone;
  int guildnum;			/* Index number of guild you belong to  */
  int guildrank;		/* Rank within guild                    */
  int multi_flags;		/* Class you've switched to             */
  int total_level;		/* Total levels gained, with above      */
  int prompt;
  int x_cord;
  int y_cord;
  int z_cord;
  int spare14;
  int spare15;
  int spare16;
  long law_flags;		/* wanted, citizen, etc			*/
  long spare18;
  long spare19;
  long spare20;
  long spare21;
};

/*
 * Specials needed only by PCs, not NPCs.  Space for this structure is
 * not allocated in memory for NPCs, but it is for PCs and the portion
 * of it labelled 'saved' is saved in the playerfile.  This structure can
 * be changed freely; beware, though, that changing the contents of
 * player_special_data_saved will corrupt the playerfile.
 */
struct player_special_data {
  struct player_special_data_saved saved;

  char *poofin;			/* Description on arrival of a god.     */
  char *poofout;		/* Description upon a god's exit.       */
  struct alias *aliases;	/* Character's aliases                  */
  long last_tell;		/* idnum of last tell from              */
  void *last_olc_targ;		/* olc control                          */
  int last_olc_mode;		/* olc control                          */
};

struct mob_attack_data {
  int min_damage;
  int max_damage;
  int attack_type;
  struct mob_attack_data *next;
};


/* Specials used by NPCs, not PCs */
struct mob_special_data {
  byte last_direction;		/* The last direction the monster went     */
  int attack_type;		/* The Attack Type Bitvector for NPC's     */
  byte default_pos;		/* Default position for NPC                */
  memory_rec *memory;		/* List of attackers to remember           */
  byte damnodice;		/* The number of damage dice's             */
  byte damsizedice;		/* The size of the damage dice's           */
  byte hp_die;			/* what die mob rolls for hit points       */
  byte hp_plus;			/* additional bonus to hit points          */
  int wait_state;		/* Wait state for bashed mobs              */
  int orig_vnum;		/* mob is a copy of vnum xx 		   */
  struct char_data *orig_char;	/* used instead of memory ptr to keep
				   track of who is controlling the mob */
  struct mob_attack_data *mob_attack;
  byte thac0;
  int last_attack;
  int last_attack_ok;
  sh_int x_cord;		/* duped, cause players need them saved */
  sh_int y_cord;
  sh_int z_cord;
  sh_int facing;
  ubyte dominant_hand;
};


/* An affect structure.  Used in char_file_u *DO*NOT*CHANGE* */
struct affected_type {
  sh_int type;			/* The type of spell that caused this      */
  sh_int duration;		/* For how long its effects will last      */
  int modifier;			/* This is added to apropriate ability     */
  byte location;		/* Tells which ability to change(APPLY_XXX) */
  ulong bitvector;		/* Tells which bits to set (AFF_XXX)       */
  ulong bitvector2;		/* Tells which bits to set (AFF2_XXX)      */
  ulong bitvector3;
  ulong bitvector4;
  struct event *affect_event;	/* The event for this affect         */

  struct affected_type *next;
};


/* Structure used for chars following other chars */
struct follow_type {
  struct char_data *follower;
  struct follow_type *next;
};


/* ================== Structure for player/non-player ===================== */
struct char_data {
  int pfilepos;			/* playerfile pos                */
  sh_int nr;			/* Mob's rnum                    */
  long id;			/* Unique identifier             */
  room_rnum in_room;		/* Location (real room number)   */
  room_rnum was_in_room;	/* location for linkdead people  */

  struct char_player_data player;	/* Normal data                   */
  struct char_ability_data real_abils;	/* Abilities without modifiers   */
  struct char_ability_data aff_abils;	/* Abils with spells/stones/etc  */
  struct char_point_data points;	/* Points                        */
  struct char_special_data char_specials;	/* PC/NPC specials        */
  struct player_special_data *player_specials;	/* PC specials            */
  struct mob_special_data mob_specials;		/* NPC specials           */

  struct affected_type *affected;	/* affected by what spells       */
  struct obj_data *equipment[NUM_WEARS];	/* Equipment array               */

  struct obj_data *carrying;	/* Head of list                  */

  struct descriptor_data *desc;	/* NULL for mobiles              */

  struct trig_proto_list *proto_script; /* list of default triggers      */
  struct script_data *script;         	/* script info for the object    */
  struct script_memory *memory;		/* for trigger memory		 */

  struct char_data *next_in_room;	/* For room->people - list        */
  struct char_data *next;		/* For either monster or ppl-list */
  struct char_data *next_in_furniture; 	/* For obj->people - list         */

  sh_int *completed_quests;	/* Quests completed               */
  int num_completed_quests;	/* Number completed               */
  int current_quest;		/* vnum of current quest          */

  struct player_disguise_data disguise;
  struct char_data *switched;

  struct follow_type *followers;	/* List of chars followers        */
  struct char_data *master;	/* Who is char following?         */
  struct event *points_event[3];	/* events for regening H/M/V      */
  int mpactnum;
};

/* ====================================================================== */


/* ==================== File Structure for Player ======================= */
/*             BEWARE: Changing it will ruin the playerfile               */
struct char_file_u {
  /* char_player_data */
  char name[MAX_NAME_LENGTH + 1];
  char description[EXDSCR_LENGTH];
  char short_descr[MAX_SHORTDESC_LENGTH + 1];
  char title[MAX_TITLE_LENGTH + 1];
  byte sex;
  byte class;
  sh_int race;
  byte level;
  byte size;
  sh_int hometown;
  time_t birth;			/* Time of birth of character     */
  int played;			/* Number of secs played in total */
  ubyte weight;
  ubyte height;

  char pwd[MAX_PWD_LENGTH + 1];	/* character's password */

  struct char_special_data_saved char_specials_saved;
  struct player_special_data_saved player_specials_saved;
  struct char_ability_data abilities;
  struct char_point_data points;
  struct affected_type affected[MAX_AFFECT];

  sh_int completed_quests[MAX_COMPLETED_QUESTS];
  int current_quest;

  time_t last_logon;		/* Time (in secs) of last logon */
  char host[HOST_LENGTH + 1];	/* host of last logon */
};

/* ====================================================================== */


/* descriptor-related structures ***************************************** */


struct txt_block {
  char *text;
  int aliased;
  struct txt_block *next;
};


struct txt_q {
  struct txt_block *head;
  struct txt_block *tail;
};


struct descriptor_data {
  socket_t descriptor;		/* file descriptor for socket           */
  char host[HOST_LENGTH + 1];	/* hostname                             */
  byte close_me;		/* flag: this desc. should be closed    */
  byte bad_pws;			/* number of bad pw attemps this login  */
  byte idle_tics;		/* tics idle at password prompt         */
  int connected;		/* mode of 'connectedness'              */
  int wait;			/* wait for how many loops              */
  int desc_num;			/* unique num assigned to desc          */
  time_t login_time;		/* when the person connected            */
  char *showstr_head;		/* for keeping track of an internal str */
  char **showstr_vector;	/* for paging through texts             */
  int showstr_count;		/* number of pages to page through      */
  int showstr_page;		/* which page are we currently showing? */
  char **str;			/* for the modify-str system            */
  size_t max_str;		/*              -                       */
  char *backstr;		/* added for handling abort buffers     */
  long mail_to;			/* name for mail system                 */
  int has_prompt;		/* is the user at a prompt?             */
  char inbuf[MAX_RAW_INPUT_LENGTH];	/* buffer for raw input           */
  char last_input[MAX_INPUT_LENGTH];	/* the last input                 */
  char small_outbuf[SMALL_BUFSIZE];	/* standard output buffer         */
  char *output;			/* ptr to the current output buffer     */
  int bufptr;			/* ptr to end of current output         */
  int bufspace;			/* space left in the output buffer      */
#ifdef NEW_BUFFERS
  char *large_outbuf;		/* ptr to large buffer, if we need it   */
#else
  struct txt_block *large_outbuf; /* ptr to large buffer, if we need it */
#endif
  struct txt_q input;		/* q of unprocessed input               */
  struct char_data *character;	/* linked to char                       */
  struct char_data *original;	/* original char if switched            */
  struct descriptor_data *snooping;	/* Who is this char snooping       */
  struct descriptor_data *snoop_by;	/* And who is snooping this char   */
  struct descriptor_data *next;	/* link to next descriptor             */
  struct olc_data *olc;		/*. OLC info - defined in olc.h   . */
  struct abil_data *stat;	/*Order of stats */
  byte term_type;		/* terminal type */
   /* mudFTP control. */
   struct {
     char *filename;		/* Filename being written to */
     char *data;		/* Data being written */
     sh_int lines_left;		/* Lines left */
     sh_int lines_sent;		/* Lines sent so far */
     ftp_mode mode;		/* FTP_xxx */
   } ftp;
   char *username;
};


/* other miscellaneous structures ************************************** */

struct grantset_struct {
  char *cmd;
  char level;
  char pcnpc;
  char type;
  int bit;
};

struct msg_type {
  char *attacker_msg;		/* message to attacker */
  char *victim_msg;		/* message to victim   */
  char *room_msg;		/* message to room     */
};


struct message_type {
  struct msg_type die_msg;	/* messages when death                  */
  struct msg_type miss_msg;	/* messages when miss                   */
  struct msg_type hit_msg;	/* messages when hit                    */
  struct msg_type god_msg;	/* messages when hit on god             */
  struct message_type *next;	/* to next messages of this kind.       */
};


struct message_list {
  int a_type;			/* Attack type                          */
  int number_of_attacks;	/* How many attack messages to chose from. */
  struct message_type *msg;	/* List of messages.                    */
};

struct armor_apply_type {
  sh_int pd;
  sh_int dr;
};

struct body_armor_type {
  struct armor_apply_type torso;
  struct armor_apply_type arms;
  struct armor_apply_type legs;
};

struct weapon_app_type {
  sh_int mod;
  sh_int type;
  sh_int swing;
  sh_int thrust;
  sh_int range;
  sh_int parry;
  sh_int max_die;
};

struct dex_skill_type {
  sh_int p_pocket;
  sh_int p_locks;
  sh_int traps;
  sh_int sneak;
  sh_int hide;
};


struct dex_app_type {
  sh_int reaction;
  sh_int miss_att;
  sh_int defensive;
};


struct str_app_type {
  sh_int thrust;		/* To Hit (THAC0) Bonus/Penalty        */
  sh_int swing;			/* Damage Bonus/Penalty                */
  sh_int carry_w;		/* Maximum weight that can be carrried */
  sh_int wield_w;		/* Maximum weight that can be wielded  */
};


struct wis_app_type {
  byte def_adj;
  byte chance_fail;
};


struct int_app_type {
  byte max_lang;
  byte max_spell_lvl;
  byte chance_learn;
  byte max_nb_spell_lvl;
};


struct con_app_type {
  sh_int hitp;
  sh_int shock;
  sh_int special;
};


struct title_type {
  char *title_m;
  char *title_f;
  int exp;
};


/* element in monster and object index-tables   */
struct index_data {
  int virtual;			/* virtual number of this mob/obj           */
  int number;			/* number of existing units of this mob/obj */
  struct path_info *paths;
  char *farg;         /* string argument for special function     */
  struct trig_data *proto;     /* for triggers... the trigger     */
   SPECIAL(*func);
};

/* linked list for mob/object prototype trigger lists */
struct trig_proto_list {
  int vnum;                             /* vnum of the trigger   */
  struct trig_proto_list *next;         /* next trigger          */
};

struct path_perform {
  int hrmin;
  int day;
  int week;
  int month;
};

struct path_info {
  int type;			/* action, goto, etc.. */
  struct path_perform *performance;	/* daily, weekly, monthly */
  int target_room;		/* not necessarily used */
  char *arguments;		/* also, not necessarily used */
  struct path_info *next;
};

#define PATH_NONE      0
#define PATH_GOTO      1
#define PATH_ACTION    2

/* this is for the memory queue */
struct path_q {
  int pnum;
  struct char_data *mob;
  struct path_q *next;
};

/* used in the socials */
struct social_messg {
  int act_nr;
  char *command;		/* holds copy of activating command */
  char *sort_as;		/* holds a copy of a similar command or
				 * abbreviation to sort by for the parser */
  int hide;			/* ? */
  int min_victim_position;	/* Position of victim */
  int min_char_position;	/* Position of char */
  int min_level_char;		/* Minimum level of socialing char */

  /* No argument was supplied */
  char *char_no_arg;
  char *others_no_arg;

  /* An argument was there, and a victim was found */
  char *char_found;
  char *others_found;
  char *vict_found;

  /* An argument was there, as well as a body part, and a victim was found */
  char *char_body_found;
  char *others_body_found;
  char *vict_body_found;

  /* An argument was there, but no victim was found */
  char *not_found;

  /* The victim turned out to be the character */
  char *char_auto;
  char *others_auto;

  /* If the char cant be found search the char's inven and do these: */
  char *char_obj_found;
  char *others_obj_found;
};


struct location_data {
  int real_room;
  sh_int x_cord;
  sh_int y_cord;
  sh_int z_cord;
  sh_int angle;
};

struct deity_data {
  char *deity_name;
  char *deity_pantheon;
  ulong deity_major_sphere;
  ulong deity_minor_sphere;
};
