/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#define NUM_RESERVED_DESCS	8

#define COPYOVER_FILE "copyover.dat"

/* comm.c */
void send_to_all(char *messg);
void send_to_char(char *messg, struct char_data *ch);
void send_to_room(char *messg, int room);
void send_to_outdoor(char *messg);
void perform_to_all(char *messg, struct char_data *ch);
void close_socket(struct descriptor_data *d);
#ifdef MUDFTP
void   string_add(struct descriptor_data *d, char *str);
void   string_write(struct descriptor_data *d, char **txt, size_t len, long mailto, void *data);
void   smash_tilde(char *);
#endif

char *perform_act(char *orig, struct char_data *ch, struct obj_data *obj,
		  void *vict_obj, struct char_data *to, int type);

void act(char *str, int hide_invisible, struct char_data *ch,
	 struct obj_data *obj, void *vict_obj, int type);

void act2(char *see_str, char *hear_str, int hide_invis,
          struct char_data *ch, struct obj_data *obj,
          void *vict_obj, int see_type, int hear_type);


#define DIST_NOISE_NORM  3    // normal dist a non-armored char is heard
#define DIST_NOISE_MAX   20   // max dist a char is heard (with armor)
#define DIST_NOISE_TALK  9    // distance that 'say' travels.
#define DIST_NOISE_YELL  50   // distance that shouts travel.
#define DIST_WATCH       12   // distance a person can 'watch' another
#define DIST_NORM_SEE     9   // distance of normal (not watching) vision

#define TO_NOONE        0
#define PROXIMITY	1	/*All in room except ch*/
#define TO_VICT		2       /*To the victim*/
#define TO_NOTVICT	3	/*Everyone in room except victim/ch*/
#define TO_CHAR		4	/*To ch*/
#define TO_PROXIMITY    5	/*All within 3 of ch*/
#define TO_PROXIMITY2   6	/*All within 6 of ch*/
#define TO_PROXIMITY3   7	/*All Within 9 of ch*/
#define TO_GODS		8
#define TO_WORLD        9
#define TO_ZONE         10
#define TO_OTHERS	11	/*All within 6 of ch except ch/victim*/
#define CHAT_CHECK 	64	/* if chat bots should be checked for this act */
#define TO_ROOM		TO_PROXIMITY2
#define TO_SLEEP	128	/* to char, even if sleeping */

#define TO_DISTANCE     (1 << 31)  // pass this to act, OR'd with a
                                   // single DIST_*  macro

int write_to_descriptor(socket_t desc, char *txt);
void write_to_q(char *txt, struct txt_q *queue, int aliased);
void write_to_output(const char *txt, struct descriptor_data *d);
void page_string(struct descriptor_data *d, char *str, int keep_internal);

#define SEND_TO_Q(messg, desc)  write_to_output((messg), desc)
#define SENDOK(ch) (((ch)->desc && \
	(AWAKE(ch) || sleep) && !PLR_FLAGGED((ch), PLR_WRITING)) || \
	(IS_MOB(ch)))

#define USING_SMALL(d)	((d)->output == (d)->small_outbuf)
#define USING_LARGE(d)  (!USING_SMALL(d))

