
// hextor.magic.cleric.c
// Clerical type spell stuff. :)
// For use with GreyHawk Mud ONLY



#include "conf.h"
#include "sysdep.h"

#include "structs.h"
#include "dg_scripts.h"
#include "utils.h"
#include "comm.h"
#include "spells.h"
#include "handler.h"
#include "db.h"

extern struct room_data *world;
extern struct obj_data *object_list;
extern struct char_data *character_list;
extern struct index_data *obj_index;

extern struct descriptor_data *descriptor_list;
extern struct zone_data *zone_table;

extern int mini_mud;

extern struct default_mobile_stats *mob_defaults;
extern char weapon_verbs[];
extern int *max_ac_applys;
extern struct apply_mod_defaults *apmd;

void clearMemory(struct char_data *ch);
void act(char *str, int i, struct char_data *c, struct obj_data *o,
	 void *vict_obj, int j);

void damage(struct char_data *ch, struct char_data *victim,
	    int damage, int weapontype, int which, int location);

void weight_change_object(struct obj_data *obj, int weight);
void add_follower(struct char_data *ch, struct char_data *leader);
int dice(int number, int size);
extern struct spell_info_type spell_info[];
void raw_kill(struct char_data *ch, struct char_data *killer);

struct char_data *read_mobile(int, int);

// Begin Spells.

ASPELL(spell_invis_animals)
{
  byte total = 0, max = level;
  struct char_data *target, *tar_next;

  for (target = world[ch->in_room].people; target; target = tar_next) {
    tar_next = target->next_in_room;
    if (affectarea(ch, victim, loc, target, SPELL_INVIS_ANIMALS) &&
	(total < max)) {
      total++;
      act("You are now undetectable to &+yanimals&n.\r\n", TRUE, ch, NULL, target,
	  TO_VICT);
      ((*spell_info[SPELL_INVIS_ANIMALS].routines) (level, ch, NULL, target, obj, loc, 0));
    }
  }
}

ASPELL(spell_invis_undead)
{
  send_to_char("You are now undetectable to the &+Lundead&n.\r\n", victim);
  ((*spell_info[SPELL_INVIS_UNDEAD].routines) (level, ch, NULL, victim, obj, loc, 0));
}


ASPELL(spell_detect_charm)
{
  send_to_char("&+YYour eyes begin to tingle.&n", victim);
  ((*spell_info[SPELL_DETECT_CHARM].routines) (level, ch, NULL, victim, obj, loc, 0));
}


ASPELL(spell_undetectable_charm)
{
  if (!IS_AFFECTED(victim, AFF_CHARM))
    send_to_char("But they aren't charmed.\r\n", ch);
  else {
    send_to_char("&+gYour master masks his influence upon you...&n\r\n", victim);
    ((*spell_info[SPELL_UNDETECTABLE_CHARM].routines) (level, ch, NULL, victim, obj, loc, 0));
  }
}

ASPELL(spell_endure_cold)
{
  send_to_char("You can now withstand some forms of &+Bcold&n.\r\n", victim);
  ((*spell_info[SPELL_ENDURE_COLD].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_endure_heat)
{
  send_to_char("You can now withstand some forms of &+Rheat&n.\r\n", victim);
  ((*spell_info[SPELL_ENDURE_HEAT].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_pass_without_trace)
{
  send_to_char("You no longer leave any trace of your passing", victim);
  ((*spell_info[SPELL_PASS_WITHOUT_TRACE].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_cause_fear)
{
  if (makes_save(victim, savetype, 0)) {
    act("You merely laugh at $n's attempt to instill fear in you", TRUE, ch, 0, victim, TO_VICT);
    act("$N laughs at your attempt to instill fear in you", TRUE, ch, 0, victim, TO_CHAR);
  } else {
    act("$n becomes a horrifying visiage, instilling fear into you!", TRUE, ch, 0, victim, TO_VICT);
    act("You become a horrifying visiage to $N scaring $s half to death!", TRUE, ch, 0, victim, TO_CHAR);
    ((*spell_info[SPELL_CAUSE_FEAR].routines) (level, ch, NULL, victim, obj, loc, 0));
  }
}				// spell_cause ...

ASPELL(spell_remove_fear)
{
  if (!IS_AFFECTED(victim, AFF_FEAR)) {
    send_to_char("You are more able to face your fears.\r\n", victim);
    ((*spell_info[SPELL_REMOVE_FEAR].routines) (level, ch, NULL, victim, obj, loc, 0));
  } else {
    send_to_char("Your fears have been calmed.\r\n", victim);
    ((*spell_info[SPELL_REMOVE_FEAR].routines) (level, ch, NULL, victim, obj, loc, 0));
  }
}				// spell_remove_fear

ASPELL(spell_chant)
{
  send_to_char("&+mYou begin to chant in a deep voice ...\r\n", ch);
  act("&+m$N begins to chant in a deep voice ...", TRUE, 0, 0, ch, TO_NOTVICT);
  ((*spell_info[SPELL_CHANT].routines) (level, ch, NULL, victim, obj, loc, 0));
}				// spell_chant
