



// Hextor.Routines.Cleric.C
// Spell Routines for Cleric Spells
// For use with Greyhawk MUD Only!



#include "conf.h"
#include "sysdep.h"

#include "structs.h"

#include "utils.h"
#include "comm.h"
#include "spells.h"
#include "handler.h"
#include "db.h"

extern struct room_data *world;
extern struct obj_data *object_list;
extern struct char_data *character_list;
extern struct index_data *obj_index;

extern struct weather_data weather_info;
extern struct descriptor_data *descriptor_list;
extern struct zone_data *zone_table;

extern int mini_mud;

extern struct default_mobile_stats *mob_defaults;
extern char weapon_verbs[];
extern int *max_ac_applys;
extern struct apply_mod_defaults *apmd;

void clearMemory(struct char_data *ch);
void act(char *str, int i, struct char_data *c, struct obj_data *o,
	 void *vict_obj, int j);

void damage(struct char_data *ch, struct char_data *victim,
	    int damage, int weapontype, int which, int location);

void weight_change_object(struct obj_data *obj, int weight);
void add_follower(struct char_data *ch, struct char_data *leader);
int dice(int number, int size);
extern struct spell_info_type spell_info[];


struct char_data *read_mobile(int, int);

AROUTINE(r_invis_animals)
{
  struct affected_type *af;

  CREATE(af, struct affected_type, 1);

  af->type = SPELL_INVIS_ANIMALS;
  af->level = level;
  af->duration = level;

  affect_to_char(vict, af);
  FREE(af);
  return 1;
}

AROUTINE(r_invis_undead)
{
  struct affected_type *af;

  CREATE(af, struct affected_type, 1);

  af->type = SPELL_INVIS_UNDEAD;
  af->level = level;
  af->duration = level;

  affect_to_char(vict, af);
  FREE(af);
  return 1;
}

AROUTINE(r_detect_charm)
{
  struct affected_type *af;

  CREATE(af, struct affected_type, 1);
  af->type = SPELL_DETECT_CHARM;
  af->level = level;
  af->duration = 1;

  affect_to_char(vict, af);

  FREE(af);
  return 1;
}

AROUTINE(r_undetectable_charm)
{
  struct affected_type *af;

  CREATE(af, struct affected_type, 1);
  af->type = SPELL_UNDETECTABLE_CHARM;
  af->level = level;
  af->duration = 24 * 75;	// assuming 24 hours in a day... no fuckin' clue how long a duration of 1 lasts...

  affect_to_char(vict, af);
  FREE(af);
  return 1;
}

AROUTINE(r_endure_cold)
{
  struct affected_type *af;


  CREATE(af, struct affected_type, 1);
  af->type = SPELL_ENDURE_COLD;
  af->level = level;
  af->duration = (level * (75 + (75 / 2)));

  affect_to_char(vict, af);
  FREE(af);
  return 1;
}


AROUTINE(r_endure_heat)
{
  struct affected_type *af;


  CREATE(af, struct affected_type, 1);
  af->type = SPELL_ENDURE_HEAT;
  af->level = level;
  af->duration = (level * (75 + (75 / 2)));

  affect_to_char(vict, af);
  FREE(af);
  return 1;
}

AROUTINE(r_pass_without_trace)
{
  struct affected_type *af;


  CREATE(af, struct affected_type, 1);
  af->type = SPELL_PASS_WITHOUT_TRACE;
  af->level = level;
  af->duration = level;

  affect_to_char(vict, af);
  FREE(af);
  return 1;
}

AROUTINE(r_cause_fear)
{
  struct affected_type *af;

  CREATE(af, struct affected_type, 1);

  af->type = SPELL_CAUSE_FEAR;
  af->level = level;
  af->duration = dice(1, 4);
  af->bitvector = AFF_FEAR;

  affect_to_char(vict, af);
  FREE(af);

  return 1;
}

AROUTINE(r_remove_fear)
{
  struct affected_type *Af;

  CREATE(Af, struct affected_type, 1);

  if (IS_AFFECTED(vict, AFF_FEAR)) {
    REMOVE_BIT(AFF_FLAGS(vict), AFF_FEAR);
    affect_from_char(vict, SPELL_CAUSE_FEAR);
    return 1;
  } else {
    Af->type = SPELL_REMOVE_FEAR;
    Af->level = level;
    Af->duration = 1;

    affect_to_char(vict, Af);
    FREE(Af);
    return 1;
  }

}

AROUTINE(r_cleric_chant)
{
  struct affected_type *af;

  CREATE(af, struct affected_type, 1);
  af->type = SPELL_CHANT;
  af->level = level;
  af->duration = -1;

  affect_to_char(vict, af);
  FREE(af);

  // insert event code here... heh

  return 1;
}
