/*******************************************************
ships.h
any probs email me at stil@citylinq.com or talk to me as
Foo on the mud
Ship structure and definitions are here :P
*******************************************************/

#define MAXSHIPS 500
#define MAXSLOTS 10

#define FORE 0
#define PORT 1
#define REAR 2
#define STARBOARD 3

#define SHRTRANGE 0
#define MEDRANGE 1
#define LNGRANGE 2

/********************************************
Slots are the "equipment" of ships
MAXSLOTS is the maximum slots a ship can have at a time
here are some example slots and what they are:
Weapons: (takes 1 slot)
  type = 1
  weight = 0-255
  position = FORE/PORT/STARBOARD/REAR
  desc = weapon desc IE "Large Ballistae"
  val0 = Minimum Range
  val1 = Maximum Range
  val2 = Damage
  val3 = hp

Oarsman: (Takes 2 slots)
  type = 2
  weight = 0-255
  position = Same as Weapon
  desc = description of oarsman IE "Strong Oarsman"
  val0 = turn rate adjustment
  val1 = speed adjustment
  val2 = repair speed

Ammunition: (1 slot)
  type = 3
  weight = 0-255
  position = same as weapon
  desc = Ammo description IE "Ammo"
  val0 = Ammo type (0 ballistae, 1 catapult, etc etc will define later)
  val1 = Capacity
  val2 = ammount of ammo

these are just some examples of what slots can be used
********************************************/
struct ship_slot
{
  char type; //type of slot
  char  position;  //Position of slot F P R S
  unsigned char weight; //Weight
  char desc[256]; //Description of slot
  char val0, val1, val2, val3; //Values
  unsigned char x, y; //Slot x, y position on ship room
  short int timer;
};

struct ship_crew
{
  char crewname[256];  //Crew desc
  char speedadjust, //Adjustment to speed
       gunadjust,   //gunnery adjustment
    repairspeed; //repair speed
};

struct ship_data
{
  unsigned char maxfarmor, maxrarmor, maxparmor, maxsarmor, //Armor maxes
    maxfinternal, maxrinternal, maxsinternal, maxpinternal, //Internal maxes
    farmor, finternal, //Fore Armor/Internal
    rarmor, rinternal,   //Rear Armor/internal
    sarmor, sinternal,   //Starboard armor/internal
    parmor, pinternal,   //Port Armor/internal
    maxturnrate, turnrate,  //Maxturn/current turn rate
    mainsail, maxmainsail,   //main sail HP/Armor thingie
    hullweight, //Weight of hull 255 could mean 255 tonnes etc etc
    maxslots;  //Max number of slots on ship
  float x,y,z,dx,dy,dz; //X,Y,Z coords and their Deltas
  struct ship_crew sailcrew; //Sail Crew 0 for none
  struct ship_crew guncrew; //Gunnery Crew 0 for none
  struct ship_slot slot[MAXSLOTS];  //number of slots
  char owner[64];  //Owner of ship, probably wrong
  struct obj_data *shipobj;  //Object linked to ship also prob wrong
  char name[128], //name of Ship
    id[2];  //designation of ship AA-ZZ
  int dock, //room ship is docked in
    shiproom, //The Vnum of ship room IE what player sees
    shipnum,
    location;  //Current room ship is in might remove and make
                  //same as Docked                  
    short int heading,  //current heading
    setheading, //set heading
    minspeed,maxspeed,speed,setspeed; // speeds
    struct event *action; //Ship action event
};

struct contact_data
{
  int shipnum,x,y,z, bearing;
  float range;
  char arc[3];
};

struct ship_action_event
{
  int shipnum;
};

struct ship_map
{
  char map[10];
};