/*
 **************************************************************************
 *  File: sound.h                                          Part of Greyhawk
 *  Usage: sound fonction for MSP
 *  Copyright  1998 - Greyhawk Adventures.
 **************************************************************************
 */

void play_sound(const char *mess, struct char_data *ch, int where, int xcord, int ycord, int zcord, int type);

#define SOUND_OFF            "!!SOUND(off)"
#define SOUND_ACID_BLAST     "!!SOUND(acid_blast.wav L=1)"
#define SOUND_ARGH           "!!SOUND(argh.wav L=1)"
#define SOUND_ARROW1         "!!SOUND(arrow1.wav L=1)"
#define SOUND_ARROW2         "!!SOUND(arrow2.wav L=1)"
#define SOUND_ARROW3         "!!SOUND(arrow3.wav L=1)"
#define SOUND_BACKSTAB       "!!SOUND(backstab.wav L=1)"
#define SOUND_BIRDS1         "!!SOUND(birds1.wav L=1)"
#define SOUND_BIRDS2         "!!SOUND(birds2.wav L=1)"
#define SOUND_BIRDS3         "!!SOUND(birds3.wav L=1)"
#define SOUND_BLESS          "!!SOUND(bless.wav L=1)"
#define SOUND_BOING          "!!SOUND(boing.wav L=1)"
#define SOUND_BOW_DOWN       "!!SOUND(bow_down.wav L=1)"
#define SOUND_CALL_LIGHTNING "!!SOUND(call_lightning.wav L=1)"
#define SOUND_CHANT1         "!!SOUND(chant1.wav L=1)"
#define SOUND_COME_BACK      "!!SOUND(come_back.wav L=1)"
#define SOUND_CRICKETS       "!!SOUND(crickets.wav L=1)"
#define SOUND_CROSSBOW_BOLT  "!!SOUND(crossbow_bolt.wav L=1)"
#define SOUND_CROWD_CLAPPING "!!SOUND(crowd_clapping.wav L=1)"
#define SOUND_CURSE          "!!SOUND(curse.wav L=1)"
#define SOUND_DEAD           "!!SOUND(dead.wav L=1)"
#define SOUND_DEATH_CRY      "!!SOUND(death_cry.wav L=1)"
#define SOUND_DOG1           "!!SOUND(dog1.wav L=1)"
#define SOUND_DOOR           "!!SOUND(door.wav L=1)"
#define SOUND_DOOR1          "!!SOUND(door1.wav L=1)"
#define SOUND_DRAGON1        "!!SOUND(dragon1.wav L=1)"
#define SOUND_DRAGON2        "!!SOUND(dragon2.wav L=1)"
#define SOUND_DRAGON3        "!!SOUND(dragon3.wav L=1)"
#define SOUND_EARTHQUAKE1    "!!SOUND(earthquake1.wav L=1)"
#define SOUND_EARTHQUAKE2    "!!SOUND(earthquake2.wav L=1)"
#define SOUND_ELECTRIC       "!!SOUND(electric.wav L=1)"
#define SOUND_ELEMENTAL      "!!SOUND(elemental.wav L=1)"
#define SOUND_EXIT_GAME      "!!SOUND(exit_game.wav L=1)"
#define SOUND_FALLING1       "!!SOUND(falling1.wav L=1)"
#define SOUND_FARSITE        "!!SOUND(farsite.wav L=1)"
#define SOUND_FIREBALL       "!!SOUND(fireball.wav L=1)"
#define SOUND_FIRESTORM      "!!SOUND(firestorm.wav L=1)"
#define SOUND_FIST           "!!SOUND(Fist.wav L=1)"
#define SOUND_F_SHARDS       "!!SOUND(f_shards.wav L=1)"
#define SOUND_GLASS1         "!!SOUND(glass1.wav L=1)"
#define SOUND_GLASS2         "!!SOUND(glass2.wav L=1)"
#define SOUND_GLASS3         "!!SOUND(glass3.wav L=1)"
#define SOUND_GLASS4         "!!SOUND(glass4.wav L=1)"
#define SOUND_TRANS_PLAYER   "!!SOUND(god_trans_player.wav L=1)"
#define SOUND_GOOD_MASTER    "!!SOUND(good_master.wav L=1)"
#define SOUND_HAMMER         "!!SOUND(hammer_on_shield.wav L=1)"
#define SOUND_HARP           "!!SOUND(harp.wav L=1)"
#define SOUND_HORSE1         "!!SOUND(horse1.wav L=1)"
#define SOUND_HORSE2         "!!SOUND(horse2.wav L=1)"
#define SOUND_LAUGH          "!!SOUND(laugh.wav L=1)"
#define SOUND_LAWPAY         "!!SOUND(lawpay.wav L=1)"
#define SOUND_MMISSILE       "!!SOUND(magic_missle.wav L=1)"
#define SOUND_MISC1          "!!SOUND(misc1.wav L=1)"
#define SOUND_MOONWELL       "!!SOUND(moonwell.wav L=1)"
#define SOUND_MUMMY          "!!SOUND(mummy.wav L=1)"
#define SOUND_NONEPASS       "!!SOUND(nonepass.wav L=1)"
#define SOUND_PEOPLE         "!!SOUND(people.wav L=1)"
#define SOUND_PORTAL         "!!SOUND(portal.wav L=1)"
#define SOUND_PUNCH          "!!SOUND(punch.wav L=1)"
#define SOUND_PUNCH2         "!!SOUND(punch2.wav L=1)"
#define SOUND_RAISE_DEAD     "!!SOUND(raise_dead.wav L=1)"
#define SOUND_RECALL         "!!SOUND(recall.wav L=1)"
#define SOUND_RECALL2        "!!SOUND(recall2.wav L=1)"
#define SOUND_RESSURECTION   "!!SOUND(ressurection.wav L=1)"
#define SOUND_RETREAT_CAVE   "!!SOUND(retreat_cave.wav L=1)"
#define SOUND_RUMBLE         "!!SOUND(rumble.wav L=1)"
#define SOUND_RUNAWAY        "!!SOUND(runaway.wav L=1)"
#define SOUND_RUN_FOOLS      "!!SOUND(run_fools.wav L=1)"
#define SOUND_SANC           "!!SOUND(sanc.wav L=1)"
#define SOUND_SANC_OUT       "!!SOUND(sanc_out.wav L=1)"
#define SOUND_SCREAM         "!!SOUND(scream.wav L=1)"
#define SOUND_SHOCKING_GRASP "!!SOUND(shocking_grasp.wav L=1)"
#define SOUND_SHOCKWAVE      "!!SOUND(shoc.wave.wav L=1)"
#define SOUND_SPELL1         "!!SOUND(spell_type1.wav L=1)"
#define SOUND_SPELL2         "!!SOUND(spell_type2.wav L=1)"
#define SOUND_SPELL3         "!!SOUND(spell_type3.wav L=1)"
#define SOUND_START_GAME     "!!SOUND(start_game.wav L=1)"
#define SOUND_STEEL_DOOR     "!!SOUND(steel_door.wav L=1)"
#define SOUND_SWORD1         "!!SOUND(sword1.wav L=1)"
#define SOUND_SWORD2         "!!SOUND(sword2.wav L=1)"
#define SOUND_SWORD3         "!!SOUND(sword3.wav L=1)"
#define SOUND_THUNDER        "!!SOUND(thunder.wav L=1)"
#define SOUND_THUNDER1       "!!SOUND(thunder1.wav L=1)"
#define SOUND_THUNDER2       "!!SOUND(thunder2.wav L=1)"
#define SOUND_TOWN_JANITOR   "!!SOUND(town_janitor.wav L=1)"
#define SOUND_TREMOR         "!!SOUND(tremor.wav L=1)"
#define SOUND_TRUMPET        "!!SOUND(trumpet.wav L=1)"
#define SOUND_WATER          "!!SOUND(water.wav L=1)"
#define SOUND_WATER1         "!!SOUND(water1.wav L=1)"
#define SOUND_WATER_DROP     "!!SOUND(water_drop.wav L=1)"
#define SOUND_WHIP           "!!SOUND(whip.wav L=1)"
#define SOUND_WHIP2          "!!SOUND(whip2.wav L=1)"
#define SOUND_WIND           "!!SOUND(wind.wav L=1)"
#define SOUND_WIND1          "!!SOUND(wind1.wav L=1)"
#define SOUND_WIND2          "!!SOUND(wind2.wav L=1)"
#define SOUND_WIND3          "!!SOUND(wind3.wav L=1)"

#define MUSIC_OFF            "!!MUSIC(off)"
#define MUSIC_BAL            "!!MUSIC(Bal.mid L=1)"
#define MUSIC_COMBAT         "!!MUSIC(combat_music.mid L=1)"
#define MUSIC_CAST_AWE       "!!MUSIC(cstl_awe.mid L=1)"
#define MUSIC_HAUNTED_HOUSE  "!!MUSIC(haunted_house_music.mid L=1)"
#define MUSIC_CAVE_AWE       "!!MUSIC(cave_awe.mid L=1)"
#define MUSIC_TIAMAT         "!!MUSIC(tiamat_song.mid L=1)"
#define MUSIC_WALK_AWE       "!!MUSIC(walk_awe.mid L=1)"
