


/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#include "conf.h"
#include "sysdep.h"

#include "structs.h"
#include "db.h"
#include "interpreter.h"
#include "utils.h"

#define MAXSHIPROOM 45099

extern struct room_data *world;
extern int top_of_world;
extern int top_of_zone_table;
extern struct zone_data *zone_table;
extern int mini_mud;
extern struct index_data *mob_index;
extern struct index_data *obj_index;
extern void assign_vrallis_procs(void);

/* functions to perform assignments */

void ASSIGNMOB(int mob, SPECIAL(fname))
{
  int rnum;

  if ((rnum = real_mobile(mob)) >= 0)
    mob_index[rnum].func = fname;
  else if (!mini_mud) {
    sprintf(buf, "SYSERR: Attempt to assign spec to non-existant mob #%d",
	    mob);
    log(buf);
  }
}

void ASSIGNOBJ(int obj, SPECIAL(fname))
{
  if (real_object(obj) >= 0)
    obj_index[real_object(obj)].func = fname;
  else if (!mini_mud) {
    sprintf(buf, "SYSERR: Attempt to assign spec to non-existant obj #%d",
	    obj);
    log(buf);
  }
}

void ASSIGNROOM(int room, SPECIAL(fname))
{
  if (real_room(room) >= 0)
    world[real_room(room)].func = fname;
  else if (!mini_mud) {
    sprintf(buf, "SYSERR: Attempt to assign spec to non-existant rm. #%d",
	    room);
    log(buf);
  }
}

void ASSIGNZONE(int zone, SPECIAL(fname))
{
  if (zone >= 0 && zone <= top_of_zone_table)
    zone_table[zone].func = fname;
  else if (!mini_mud) {
    sprintf(buf, "SYSERR: Attempt to assign spec to non-existant zone. #%d",
	    zone);
    log(buf);
  }
}
/* ********************************************************************
   *  Assignments                                                        *
   ******************************************************************** */

/* assign special procedures to mobiles */
void assign_mobiles(void)
{
/*  void assign_kings_castle(void); */
  SPECIAL(postmaster);
  SPECIAL(questmaster);
  SPECIAL(armorer);
  SPECIAL(weaponist);
  SPECIAL(greyhawk_cityguard);
  SPECIAL(city_dog);
  SPECIAL(rosalia_waitress);
  SPECIAL(drunk_one);
  SPECIAL(drunk_two);
  SPECIAL(drunk_three);
  SPECIAL(drunk_four);
  SPECIAL(drunk_five);
  SPECIAL(rentacleric);

  ASSIGNMOB(1, questmaster);
  ASSIGNMOB(10, postmaster);
  ASSIGNMOB(5007, greyhawk_cityguard);
  ASSIGNMOB(5011, city_dog);
  ASSIGNMOB(5009, rosalia_waitress);
  ASSIGNMOB(5110, drunk_one);
  ASSIGNMOB(5111, drunk_two);
  ASSIGNMOB(5112, drunk_three);
  ASSIGNMOB(5113, drunk_four);
  ASSIGNMOB(5114, drunk_five);
  ASSIGNMOB(5801, rentacleric);
//  ASSIGNMOB(11700, armorer);
  // ASSIGNMOB(11701, weaponist);
  /*   assign_kings_castle(); */
}



/* assign special procedures to objects */
void assign_objects(void)
{
  SPECIAL(changelog);
  SPECIAL(ship_object);
  SPECIAL(ship_loader);
  SPECIAL(foo_staff);

  ASSIGNOBJ(203, changelog);
  ASSIGNOBJ(4500, ship_object);
  ASSIGNOBJ(4501, ship_loader);
  ASSIGNOBJ(103, foo_staff);
  assign_vrallis_procs();
}

/* assign special procedures to zones */
void assign_zones(void)
{
}

/* assign special procedures to rooms */
void assign_rooms(void)
{
  extern int dts_are_dumps;
  int i;

  SPECIAL(dump);
  SPECIAL(pet_shops);
  SPECIAL(ship_commands);

  if (dts_are_dumps)
    for (i = 0; i < top_of_world; i++)
      if (IS_SET(ROOM_FLAGS(i), ROOM_DEATH))
	world[i].func = dump;

  ASSIGNROOM(5353, pet_shops);

  for (i = 45000; i <= MAXSHIPROOM; i++) {
    ASSIGNROOM(i, ship_commands);
  }
}
